![tests](https://github.com/tagordon/gefera/actions/workflows/tests.yml/badge.svg)
[![Documentation Status](https://readthedocs.org/projects/gefera/badge/?version=latest)](https://gefera.readthedocs.io/en/latest/?badge=latest)

# gefera

[Installation](#installation)

[Basic Usage](#basic-usage)

[The Likelihood](#the-likelihood)

## Installation

To install gefera begin by cloning the github repository. 

```
git clone https://www.github.com/tagordon/gefera
```

Once the repository has downloaded cd into the main directory and install with pip.

```
cd gefera; pip install .
``` 
 
## Basic Usage

Gefera has two components: the dynamical model which is used to compute the positions of two bodies at a given time or array of times, and the photometric model which computes the observed flux given the positions of the bodies. Gefera implements two dynamical systems. The first is a `HierarchicalSystem`, which describes an exomoon/exoplanet pair. To instantiate this system let's start by defining the dynamical parameters:

For the planet:

```python
ap = 215.0			# semimajor axis in stellar radii
tp = -91.25			# starting epoch in days
ep = 0.0			# eccentricity 
pp = 365			# period in days
wp = 0.1 * np.pi / 180		# longitude of periastron in degrees
ip = 89.8 * np.pi / 180		# inclination in degrees
```

and for the moon:    

```python
am = 2			# semimajor axis of the moon's orbit around the planet in stellar radii
tm = -4.2			# starting epoch in days
em = 0.0			# eccentricity
pm = 8				# period in days
om = 90 * np.pi / 180		# longitude of the ascending node in degrees
wm = -90 * np.pi / 180		# longitude of periastron in degrees
im = 90.0 * np.pi / 180		# inclination in degrees
mm = 0.01			# mass of the moon in units of the mass of the planet
```

We can then instantiate the system as follows: 

```python
import gefera as gf

po = gf.orbits.PrimaryOrbit(ap, tp, ep, pp, wp, ip)
mo = gf.orbits.SatelliteOrbit(am, tm, em, pm, om, wm, im, mm)
sys = gf.systems.HierarchicalSystem(po, mo)
```

To compute the light curve we also need the radii of both bodies and the quadratic limb darkening parameters (right now gefera only supports quadratic limb darkening)

```python
rp = 0.1
rm = 0.05
u1 = 0.5
u2 = 0.3
```

We can then compute the light curve:

```python
t = np.linspace(-0.6, 0.3, 10000)
# The out-of-transit flux is set to zero by default, so we add 1 to get the normalized flux.
flux = sys.lightcurve(t, u1, u2, rp, rm) + 1
```
When plotted, the lightcurve for this system looks like this:
![exomoon lightcurve](https://github.com/tagordon/gefera/blob/master/notebooks/readme_plot_light.png#gh-light-mode-only)
![exomoon lightcurve](https://github.com/tagordon/gefera/blob/master/notebooks/readme_plot_dark.png#gh-dark-mode-only)

If the gradient is required we use

```python
flux, grad = sys.lightcurve(t, u1, u2, rp, rm, grad=True)
```

This will return the gradient of the light curve with respect to each of the input parameters as a dictionary keyed by the name of the parameter. The keys are `a1, t1, e1... a2, t2, e2...` where the `1` parameters are for the larger body and `2` refers to the smaller body. 

## The Likelihood 

In order to conduct inference using the gefera model we need to compute the likelihood with respect to some observations. If `t` is an array containing the times of the observations and `y` is an array containing flux measurements (normalized to an out-of-transit flux of 1) then we can compute the likelihood for the model as follows:

```python
ll = sys.loglike(y - 1, t, u1, u2, r1, r2, sigma)
``` 

where `sigma` is the uncertainty, assumed to be the same for each measurement. If we want to make use of the gradient in our inference then we can call:

```python
ll, dll = sys.loglike(y - 1, t, u1, u2, r1, r2, sigma, grad=True)
```

The gradient is returned as an array of arrays containing the gradients with respect to each parameter in the order `a1, t1, e1, p1, w1, i1, a2, t2, e2, p2, om2, w2, i2, mm2, r1, r2, u1, u2`. If `func` is a callable function that returns `-ll, -dll` and `init` is an array of initial parameter guesses in the same order as the gradients are returned then we can use `scipy.optimize.minimize` to optimize the model as follows:

```python
res = minimize(func, init, jac=True, method='TNC')
```

module phot
use iso_c_binding
use ellip

implicit none

!real*8, parameter :: pi = 4.d0 * Atan(1.d0), pihalf = 2.d0 * Atan(1.d0)
real*8, parameter :: twopithree = 8.d0 * Atan(1.d0) / 3.d0, twopi = 8.d0 * Atan(1.d0)
real*8, parameter :: o3 = 1.d0 / 3.d0, o9 = 1.d0 / 9.d0
real*8, parameter :: pithird = 4.d0 * Atan(1.d0) / 3.d0, pisixth = 4.d0 * Atan(1.d0) / 6.d0

contains

subroutine phis(rp, rm, bp, bm, bpm, cth, sth, pp1, pp2, pm1, pm2, pp_rp, pp_rm, pp_bpm, &
                pm_rp, pm_rm, pm_bpm, thetam_bp, thetam_bpm, thetam_theta)

    real*8 :: rp, rm, bp, bm, bpm, cth, sth
    
    ! intersection angle from planet center, intersection from moon center, same 
    ! values relative to bp and bm vectors respectively
    real*8 :: pp, pm, pp1, pm1, pp2, pm2
    
    ! derivatives 
    real*8 :: pp_rp, pp_rm, pp_bpm ! pp_theta = 1
    real*8 :: pm_rp, pm_rm, pm_bpm, thetam_theta, thetam_bp, thetam_bpm
    
    ! Four times the area of the triangle formed by rm, rp, and bpm
    real*8 :: delta
    ! Variables used in sorting the sides of the triangle
    real*8 :: a, b, c, tmp
    
    ! angle between bpm vector and bp vector, 
    ! angle between bpm vector and bm vector
    real*8 :: theta, thetam
    
    ! for avoiding divisions
    real*8 :: denom, obm
    
    thetam = Atan2(bp * sth, bpm - bp * cth)
    theta = Atan2(sth, cth)
    obm = 1.d0 / bm
    
    ! find 4 * area of triangle using modified Heron's formula 
    a = rp
    b = rm
    c = bpm
    if (c .gt. b) then
        tmp = c
        c = b
        b = tmp
    end if
    if (b .gt. a) then
        tmp = b
        b = a
        a = tmp
    end if
    delta = Sqrt((a + (b + c)) * (c - (a - b)) * (c + (a - b)) * (a + (b - c)))
    denom = 1.d0 / (delta * bpm * rm * rp)
    
    pm = Atan2(delta, (rm - rp) * (rm + rp) + bpm * bpm)   
    pm_bpm = ((rm + bpm) * (rm - bpm) - rp * rp) * denom * rm * rp
    pm_rp = 2 * rp * denom * bpm * rm * rp
    pm_rm = ((bpm - rm) * (bpm + rm) - rp * rp) * denom * rp * bpm
    
    pp = Atan2(delta, (rp - rm) * (rp + rm) + bpm * bpm)
    !pp = Asin(rm * Sin(pm) / rp)
    pp_bpm = ((rp - rm) * (rp + rm) - bpm * bpm) * denom * rm * rp
    pp_rp = ((bpm - rp) * (bpm + rp) - rm * rm) * denom * rm * bpm
    pp_rm = 2 * rm * denom * rm * rp * bpm
    
    thetam_bp = bpm * sth * obm * obm
    thetam_theta = ((bpm - bm) * (bpm + bm) - bp * bp) * 0.5 * obm * obm
    thetam_bpm = -bp * sth * obm * obm

    pm1 = thetam + pm
    pm2 = thetam - pm
    pp1 = theta + pp
    pp2 = theta - pp
    
    if (pm1 .gt. pi) then
        pm1 = pm1 - twopi
    end if
    if (pp1 .gt. pi) then
        pp1 = pp1 - twopi
    end if

end

subroutine kappas_p(rp, bp, kp, kps, kp_rp, kp_bp, kps_rp, kps_bp)

    ! kp = angle to intersection from center of planet, 
    ! kps = angle to intersection from center of star 
    real*8 :: rp, bp, kp, kps
    
    ! derivatives 
    real*8 :: kp_rp, kp_bp, kps_rp, kps_bp
    
    ! variables used in sorting sides of triangle
    real*8 :: a, b, c
    
    ! four times the area of the triangle with sides rp, bp, and 1
    real*8 :: delta
    real*8 :: denom
    
    if (bp .gt. 1.d0) then
        a = bp
        b = 1.d0
        c = rp
    else
        a = 1.d0
        b = bp
        c = rp
        if (rp .gt. bp) then
            b = rp
            c = bp
        end if
    end if
    delta = Sqrt((a + (b + c)) * (c - (a - b)) * (c + (a - b)) * (a + (b - c)))
    denom = 1.d0 / (delta * bp * rp)
    
    kps = Atan2(delta, (1.d0 - rp) * (1.d0 + rp) + bp * bp)
    kps_bp = ((1.d0 - bp) * (1.d0 + bp) - rp * rp) * rp * denom
    kps_rp = 2 * rp * rp * bp * denom
    
    kp = Atan2(delta, (rp - 1.d0) * (rp + 1.d0) + bp * bp)
    kp_bp = ((rp + bp) * (rp - bp) - 1.d0) * rp * denom
    kp_rp = ((bp + rp) * (bp - rp) - 1.d0) * bp * denom
end 

subroutine kappas_m(rm, bp, bm, bpm, cth, sth, km, kms, km_rm, km_bp, km_bpm, km_theta, &
                    kms_rm, kms_bp, kms_bpm, kms_theta)

    ! km = angle to interection from center of moon, 
    ! kms = angle to intersection from center of planet
    real*8 :: rm, bp, bm, bpm, cth, sth, km, kms
    
    ! derivatives
    real*8 :: km_rm, km_bp, km_bpm, km_theta, kms_rm, kms_bp, kms_bpm, kms_theta
    
    ! variables used in sorting sides of triangle
    real*8 :: a, b, c
    
    ! four times the area of the triangle with sides rm, bm, and 1
    real*8 :: delta
    
    ! some useful quantities
    real*8 :: denom, xs, xm, yp, ypm, ytheta
    
    xs = (1.d0 - bm) * (1.d0 + bm) - rm * rm
    xm = (rm - bm) * (rm + bm) - 1.d0
    yp = bp - bpm * cth
    ypm = bpm - bp * cth
    ytheta = bp * bpm * sth
    
    if (bm .ge. 1.d0) then
        a = bm
        b = 1.d0
        c = rm
    else
        a = 1.d0
        b = bm
        c = rm
        if (rm .ge. bm) then
            b = rm
            c = bm
        end if
    end if
    delta = Sqrt((a + (b + c)) * (c - (a - b)) * (c + (a - b)) * (a + (b - c)))
    denom = 1.d0 / (delta * bm * bm)
    
    km = Atan2(delta, (rm - 1.d0) * (rm + 1.d0) + bm * bm)
    kms = Atan2(delta, (1.d0 - rm) * (1.d0 + rm) + bm * bm)
    
    km_rm = ((bm + rm) * (bm - rm) - 1.d0) / (rm * delta)
    kms_rm = 2 * rm * bm * bm * denom
    
    km_theta = ytheta * xm * denom
    kms_theta = ytheta * xs * denom
    
    km_bpm = ypm * xm * denom
    kms_bpm = ypm * xs * denom
    
    km_bp = yp * xm * denom
    kms_bp = yp * xs * denom
end 

subroutine bm_x(bp, bm, bpm, cth, sth, dbm)

    real*8 :: bp, bm, bpm, cth, sth
    real*8, dimension(3) :: dbm
    real*8 :: obm 
    
    obm = 1.d0 / bm
    dbm(1) = (bp - bpm * cth) * obm
    dbm(2) = (bpm - bp * cth) * obm
    dbm(3) = bp * bpm * sth * obm
end 

! main loop to compute the flux at each timestep by finding the correct geometry and
! calling the integration routines 
subroutine flux(c1, c2, rp, rm, bp, bpm, cth, sth, lc, j) bind(C, name="flux")

    integer (c_int), bind(C) :: j
    integer :: i
    real (c_double), bind(C) :: rp, rm
    real (c_double), bind(C), dimension(j) :: bp, cth, sth, bpm
    real (c_double), bind(C), intent(out), dimension(8, j) :: lc
    real*8, dimension(8) :: f0
    real*8, dimension(3) :: ld
    real (c_double), bind(C) :: c1, c2
    real*8 :: of0
    
    ! half angles: from planet to planet/star intersection, moon to moon/star
    ! intersection, spanned by planet on limb of star, spanned by moon on 
    ! limb of star
    real*8 :: kp, km, kps, kms
        
    ! derivatives of above angles
    real*8 :: kp_rp, kp_bp, kps_rp, kps_bp
    real*8 :: km_rm, km_bp, km_bpm, km_theta
    real*8 :: kms_rm, kms_bp, kms_bpm, kms_theta
    
    ! angles to planet-moon intersection from planet center 
    !relative to bp vector (and derivatives)
    real*8 :: pp1, pp2
    real*8 :: pp_rp, pp_rm, pp_bpm ! pp_theta = 1
    
    ! angles to planet-moon intersection from moon center 
    ! relative to bm vector (and derivatves)
    real*8 :: pm1, pm2
    real*8 :: pm_rp, pm_rm, thetam_bp, pm_bpm, thetam_theta
    ! derivative of angle between bpm and bm vector with respect to bpm
    real*8 :: thetam_bpm
    
    ! used to determine cases for three body overlaps, might not be needed. 
    ! Check if some of these (costheta, cosphi) can be removed when optimizing things later 
    real*8 :: phi, phi_bpm, phi_bp, phi_theta, d1, d2, delta, a, b, c, tmp
    
    ! For chain rule stuff
    real*8, dimension(j) :: bm
    real*8, dimension(3) :: dbm, dbm0
    
    bm = Sqrt((bp - bpm)**2.d0 + 2 * bp * bpm * (1.d0 - cth))
    dbm0 = 0.d0
    
    ld(1) = 1.d0 - c1 - 2 * c2
    ld(2) = c1 + 2 * c2
    ld(3) = c2
    
    ! normalization factors 
    f0(1) = ld(1) * pi + ld(2) * twopithree + ld(3) * pihalf
    f0(2) = 0.d0
    f0(3) = 0.d0
    f0(4) = 0.d0
    f0(5) = 0.d0
    f0(6) = 0.d0
    f0(7) = -pi + twopithree 
    f0(8) = -2 * pi + 2 * twopithree + pihalf
    
    of0 = 1.d0 / f0(1)
    
    do i=1,j,1
    
        lc(:, i) = f0 * of0
        
        if (rp .gt. 1.d0 + bp(i)) then
            lc(:, i) = 0.d0
        else if (rm .gt. 1.d0 + bm(i)) then 
            lc(:, i) = 0.d0
        else if (bpm(i) .gt. rp + rm) then
            ! moon and planet don't overlap each other 
            if (bp(i) .lt. 1.d0 - rp) then
                ! planet completely inside star
                lc(:, i) = lc(:, i) - 2 * Fcomplete(ld, rp, bp(i), dbm0, .TRUE.) * of0
            else if (bp(i) .lt. 1.d0 + rp) then
                ! planet partially overlaps star
                call kappas_p(rp, bp(i), kp, kps, kp_rp, kp_bp, kps_rp, kps_bp)
                lc(:, i) = lc(:, i) - 2 * (Fstar(ld, kps, kps_rp, 0.d0, kps_bp, 0.d0, 0.d0) &
                                    + F(ld, kp, rp, bp(i), kp_rp, 0.d0, kp_bp, 0.d0, 0.d0, &
                                            dbm0, .TRUE., .TRUE.)) * of0
            end if
            if (bm(i) .lt. 1.d0 - rm) then
                ! moon completely inside star
                call bm_x(bp(i), bm(i), bpm(i), cth(i), sth(i), dbm)
                lc(:, i) = lc(:, i) - 2 * Fcomplete(ld, rm, bm(i), dbm, .FALSE.) * of0
            else if (bm(i) .lt. 1.d0 + rm) then
                ! moon partially overlaps star
                call kappas_m(rm, bp(i), bm(i), bpm(i), cth(i), sth(i), km, kms, &
                              km_rm, km_bp, km_bpm, km_theta, &
                              kms_rm, kms_bp, kms_bpm, kms_theta)
                call bm_x(bp(i), bm(i), bpm(i), cth(i), sth(i), dbm)
                lc(:, i) = lc(:, i) - 2 * (Fstar(ld, kms, 0.d0, kms_rm, kms_bp, kms_bpm, kms_theta) &
                                    + F(ld, km, rm, bm(i), 0.d0, km_rm, km_bp, km_bpm, km_theta, &
                                            dbm, .FALSE., .TRUE.)) * of0
            end if
        else
            ! moon and planet do overlap each other 
            if (bp(i) .gt. rp + 1.d0) then
                if (bm(i) .gt. rm + 1.d0) then
                    ! neither moon nor planet overlap star
                    lc(:, i) = f0 * of0
                else
                    ! moon partially overlaps star, planet does not overlap star
                    call bm_x(bp(i), bm(i), bpm(i), cth(i), sth(i), dbm)
                    call kappas_m(rm, bp(i), bm(i), bpm(i), cth(i), sth(i), km, kms, &
                                      km_rm, km_bp, km_bpm, km_theta, &
                                      kms_rm, kms_bp, kms_bpm, kms_theta)
                    lc(:, i) = 2 * (Fstar(ld, pi - kms, 0.d0, -kms_rm, -kms_bp, -kms_bpm, -kms_theta) &
                                    - F(ld, km, rm, bm(i), 0.d0, km_rm, km_bp, km_bpm, km_theta, &
                                            dbm, .FALSE., .TRUE.)) * of0

                end if
            else
                if (bm(i) .gt. rm + 1.d0) then
                    ! planet partially overlaps star, moon is outside of star
                    call kappas_p(rp, bp(i), kp, kps, kp_rp, kp_bp, kps_rp, kps_bp)
                    lc(:, i) = 2 * (Fstar(ld, pi - kps, -kps_rp, 0.d0, -kps_bp, 0.d0, 0.d0) &
                                    - F(ld, kp, rp, bp(i), kp_rp, 0.d0, kp_bp, 0.d0, 0.d0, &
                                        dbm0, .TRUE., .TRUE.)) * of0
                else
                    if (bp(i) + rp .le. 1.d0) then
                        if (bm(i) + rm .le. 1.d0) then
                            if (bpm(i) + rm .le. rp) then
                                ! moon and planet both overlap star, moon fully overlapped by planet
                                lc(:, i) = (f0 - 2 * Fcomplete(ld, rp, bp(i), dbm0, .TRUE.)) * of0
                            else
                                ! Case E
                                ! bookmark
                                ! moon and planet both overlap star, moon and planet partially overlap each other 
                                call bm_x(bp(i), bm(i), bpm(i), cth(i), sth(i), dbm)
                                call phis(rp, rm, bp(i), bm(i), bpm(i), cth(i), sth(i), pp1, pp2, pm1, pm2, pp_rp, pp_rm, pp_bpm, &
                                          pm_rp, pm_rm, pm_bpm, thetam_bp, thetam_bpm, thetam_theta)
                                lc(:, i) = (f0 - Arc(ld, pp1, pp2, rp, bp(i), &
                                                     pp_rp, pp_rm, 0.d0, pp_bpm, 1.d0, &
                                                     -pp_rp, -pp_rm, 0.d0, -pp_bpm, 1.d0, &
                                                     dbm0, .TRUE., .FALSE., .FALSE.) &
                                                - Arc(ld, pm1, pm2, rm, bm(i), &
                                                     pm_rp, pm_rm, thetam_bp, pm_bpm + thetam_bpm, thetam_theta, &
                                                     -pm_rp, -pm_rm, thetam_bp, -pm_bpm + thetam_bpm, thetam_theta, &
                                                     dbm, .FALSE., .FALSE., .FALSE.)) * of0
                            end if
                        else
                            ! Case F
                            ! planet fully overlaps star, moon partially overlaps star, both overlap each other 
                            call bm_x(bp(i), bm(i), bpm(i), cth(i), sth(i), dbm)
                            call phis(rp, rm, bp(i), bm(i), bpm(i), cth(i), sth(i), pp1, pp2, pm1, pm2, pp_rp, pp_rm, pp_bpm, &
                                      pm_rp, pm_rm, pm_bpm, thetam_bp, thetam_bpm, thetam_theta)
                            call kappas_m(rm, bp(i), bm(i), bpm(i), cth(i), sth(i), km, kms, &
                                      km_rm, km_bp, km_bpm, km_theta, &
                                      kms_rm, kms_bp, kms_bpm, kms_theta)
                            lc(:, i) = (2 * Fstar(ld, pi - kms, 0.d0, -kms_rm, -kms_bp, -kms_bpm, -kms_theta) &
                                        - Arc(ld, -km, pm2, rm, bm(i), &
                                              0.d0, -km_rm, -km_bp, -km_bpm, -km_theta, &
                                              -pm_rp, -pm_rm, thetam_bp, -pm_bpm + thetam_bpm, thetam_theta, &
                                              dbm, .FALSE., .TRUE., .FALSE.) &
                                        - Arc(ld, pm1, km, rm, bm(i), &
                                              pm_rp, pm_rm, thetam_bp, pm_bpm + thetam_bpm, thetam_theta, &
                                              0.d0, km_rm, km_bp, km_bpm, km_theta, &
                                              dbm, .FALSE., .FALSE., .TRUE.) &
                                        - Arc(ld, pp1, pp2, rp, bp(i), &
                                              pp_rp, pp_rm, 0.d0, pp_bpm, 1.d0, &
                                              -pp_rp, -pp_rm, 0.d0, -pp_bpm, 1.d0, &
                                              dbm0, .TRUE., .FALSE., .FALSE.)) * of0
                        end if
                    else
                        if (bm(i) + rm .le. 1.d0) then 
                            if (bpm(i) + rm .le. rp) then
                                ! planet partially overlaps star, moon fully overlaps star but is completely overlapped by planet 
                                call kappas_p(rp, bp(i), kp, kps, kp_rp, kp_bp, kps_rp, kps_bp)
                                lc(:, i) = 2 * (Fstar(ld, pi - kps, -kps_rp, 0.d0, -kps_bp, 0.d0, 0.d0) &
                                                - F(ld, kp, rp, bp(i), kp_rp, 0.d0, kp_bp, 0.d0, 0.d0, &
                                                    dbm0, .TRUE., .TRUE.)) * of0
                            else
                                ! planet partially overlaps star, moon fully overlaps star and only partially overlaps planet
                                call bm_x(bp(i), bm(i), bpm(i), cth(i), sth(i), dbm)
                                call phis(rp, rm, bp(i), bm(i), bpm(i), cth(i), sth(i), pp1, pp2, pm1, pm2, pp_rp, pp_rm, pp_bpm, &
                                      pm_rp, pm_rm, pm_bpm, thetam_bp, thetam_bpm, thetam_theta)
                                call kappas_p(rp, bp(i), kp, kps, kp_rp, kp_bp, kps_rp, kps_bp)
                                lc(:, i) = (2 * Fstar(ld, pi - kps, -kps_rp, 0.d0, -kps_bp, 0.d0, 0.d0) &
                                            - Arc(ld, -kp, pp2, rp, bp(i), &
                                                  -kp_rp, 0.d0, -kp_bp, 0.d0, 0.d0, &
                                                  -pp_rp, -pp_rm, 0.d0, -pp_bpm, 1.d0, &
                                                  dbm0, .TRUE., .TRUE., .FALSE.) &
                                            - Arc(ld, pp1, kp, rp, bp(i), &
                                                  pp_rp, pp_rm, 0.d0, pp_bpm, 1.d0, &
                                                  kp_rp, 0.d0, kp_bp, 0.d0, 0.d0, &
                                                  dbm0, .TRUE., .FALSE., .TRUE.) &
                                            - Arc(ld, pm1, pm2, rm, bm(i), &
                                                  pm_rp, pm_rm, thetam_bp, pm_bpm + thetam_bpm, thetam_theta, &
                                                  -pm_rp, -pm_rm, thetam_bp, -pm_bpm + thetam_bpm, thetam_theta, &
                                                  dbm, .FALSE., .FALSE., .FALSE.)) * of0
                            end if
                        else
                            if (bpm(i) + rm .le. rp) then
                                ! planet and moon both partially overlap star but moon is fully overlapped by the planet
                                call kappas_p(rp, bp(i), kp, kps, kp_rp, kp_bp, kps_rp, kps_bp)
                                lc(:, i) = 2 * (Fstar(ld, pi - kps, -kps_rp, 0.d0, -kps_bp, 0.d0, 0.d0) &
                                                - F(ld, kp, rp, bp(i), kp_rp, 0.d0, kp_bp, 0.d0, 0.d0, &
                                                    dbm0, .TRUE., .TRUE.)) * of0
                            else
                                ! bookmark
                                !call compute_theta(rp,  bp(i), theta, phip, theta_bp, theta_rp, phip_bp, phip_rp)
                                !call compute_theta(rm,  bm(i), theta, phim, theta_bm, theta_rm, phim_bm, phim_rm)
                                call kappas_p(rp, bp(i), kp, kps, kp_rp, kp_bp, kps_rp, kps_bp)
                                call kappas_m(rm, bp(i), bm(i), bpm(i), cth(i), sth(i), km, kms, &
                                      km_rm, km_bp, km_bpm, km_theta, &
                                      kms_rm, kms_bp, kms_bpm, kms_theta)
                                
                                a = bm(i)
                                b = bp(i)
                                c = bpm(i)
                                if (b .gt. a) then
                                    tmp = b
                                    b = a
                                    a = tmp
                                end if
                                if (c .gt. b) then
                                    tmp = c
                                    c = b
                                    b = tmp
                                end if
                                if (b .gt. a) then
                                    tmp = b
                                    b = a
                                    a = tmp
                                end if
                                delta = (a + (b + c)) * (c - (a - b)) * (c + (a - b)) * (a + (b - c))
                                if (delta .lt. 0.d0) then
                                    delta = 0.d0
                                else
                                    delta = Sqrt(delta)
                                end if
                                phi = Atan2(delta, (bm(i) - bpm(i)) * (bm(i) + bpm(i)) + bp(i) * bp(i))   
                                
                                call phis(rp, rm, bp(i), bm(i), bpm(i), cth(i), sth(i), pp1, pp2, pm1, pm2, pp_rp, pp_rm, pp_bpm, &
                                          pm_rp, pm_rm, pm_bpm, thetam_bp, thetam_bpm, thetam_theta)
                                
                                if (phi + kms .le. kps) then  
                                        if (abs(pp2) .gt. kp) then
                                            ! planet and moon both partially overlap the star and each other but the 
                                            ! moon-star overlap is contained within the planet-star overlap
                                            lc(:, i) = 2 * (Fstar(ld, pi - kps, -kps_rp, 0.d0, -kps_bp, 0.d0, 0.d0) &
                                                            - F(ld, kp, rp, bp(i), kp_rp, 0.d0, kp_bp, 0.d0, 0.d0, &
                                                                dbm0, .TRUE., .TRUE.)) * of0
                                        else
                                            ! planet and moon both partially overlap star and each other but the 
                                            ! moon-star intersections are overlapped by the planet
                                            call bm_x(bp(i), bm(i), bpm(i), cth(i), sth(i), dbm)
                                            lc(:, i) = (2 * Fstar(ld, pi - kps, -kps_rp, 0.d0, -kps_bp, 0.d0, 0.d0) &
                                                        - Arc(ld, -kp, pp2, rp, bp(i), &
                                                              -kp_rp, 0.d0, -kp_bp, 0.d0, 0.d0, &
                                                              -pp_rp, -pp_rm, 0.d0, -pp_bpm, 1.d0, &
                                                              dbm0, .TRUE., .TRUE., .FALSE.) &
                                                        - Arc(ld, pp1, kp, rp, bp(i), &
                                                              pp_rp, pp_rm, 0.d0, pp_bpm, 1.d0, &
                                                              kp_rp, 0.d0, kp_bp, 0.d0, 0.d0, &
                                                              dbm0, .TRUE., .FALSE., .TRUE.) &
                                                        - Arc(ld, pm1, pm2, rm, bm(i), &
                                                              pm_rp, pm_rm, thetam_bp, pm_bpm + thetam_bpm, thetam_theta, &
                                                              -pm_rp, -pm_rm, thetam_bp, -pm_bpm + thetam_bpm, thetam_theta, &
                                                              dbm, .FALSE., .FALSE., .FALSE.)) * of0
                                        end if
    
                                else if (phi + kps .le. kms) then
                                    call bm_x(bp(i), bm(i), bpm(i), cth(i), sth(i), dbm)
                                    if ((bp(i) - rp) .le. (bm(i) - rm)) then
                                        ! Case L
                                        ! planet and moon both partially overlap the star and each other but the 
                                        ! planet-star intersections are overlapped by the moon
                                        lc(:, i) = (2 * Fstar(ld, pi - kms, 0.d0, -kms_rm, -kms_bp, -kms_bpm, -kms_theta) &
                                                        - Arc(ld, -km, pm2, rm, bm(i), &
                                                              0.d0, -km_rm, -km_bp, -km_bpm, -km_theta, &
                                                              -pm_rp, -pm_rm, thetam_bp, -pm_bpm + thetam_bpm, thetam_theta, &
                                                              dbm, .FALSE., .TRUE., .FALSE.) &
                                                        - Arc(ld, pm1, km, rm, bm(i), &
                                                              pm_rp, pm_rm, thetam_bp, pm_bpm + thetam_bpm, thetam_theta, &
                                                              0.d0, km_rm, km_bp, km_bpm, km_theta, &
                                                              dbm, .FALSE., .FALSE., .TRUE.) &
                                                        - Arc(ld, pp1, pp2, rp, bp(i), &
                                                              pp_rp, pp_rm, 0.d0, pp_bpm, 1.d0, &
                                                              -pp_rp, -pp_rm, 0.d0, -pp_bpm, 1.d0, &
                                                              dbm0, .TRUE., .FALSE., .FALSE.)) * of0
                                    else
                                        ! planet and moon both partially overlap the star and each other but 
                                        ! the planet-star overlap is  entirely within the moon-star overlap
                                        lc(:, i) = 2 * (Fstar(ld, pi - kms, 0.d0, -kms_rm, -kms_bp, -kms_bpm, -kms_theta) &
                                                        - F(ld, km, rm, bm(i), 0.d0, km_rm, km_bp, km_bpm, km_theta, &
                                                            dbm, .FALSE., .TRUE.)) * of0
                                    end if
                                else
                                    ! bookmark
                                    d1 = rm * rm + bm(i) * bm(i) - 2 * rm * bm(i) * Cos(pm2)
                                    d2 = rm * rm + bm(i) * bm(i) - 2 * rm * bm(i) * Cos(pm1)
                                    call bm_x(bp(i), bm(i), bpm(i), cth(i), sth(i), dbm)
                                    if ((d1 .gt. 1.d0) .AND. (d2 .gt. 1.d0)) then
                                        ! planet and moon both partially overlap star and each other, 
                                        ! but the planet/moon overlap does not overlap the star
                                        if (pp1 * pp2 .lt. 0.d0) then
                                            lc(:, i) = 0.d0
                                        else
                                            lc(:, i) = 2 * (Fstar(ld, pi - (kps + kms), -kps_rp, -kms_rm, &
                                                              -(kps_bp + kms_bp), -kms_bpm, -kms_theta) &
                                                        - F(ld, kp, rp, bp(i), kp_rp, 0.d0, kp_bp, 0.d0, 0.d0, &
                                                            dbm0, .TRUE., .TRUE.) &
                                                        - F(ld, km, rm, bm(i), 0.d0, km_rm, km_bp, km_bpm, km_theta, &
                                                            dbm, .FALSE., .TRUE.)) * of0
                                        end if
                                    else if ((d1 .le. 1.d0) .AND. (d2 .le. 1.d0)) then
                                        ! planet and moon both partially overlap star and each other, 
                                        ! with the planet/moon overlap fully overlapping the star
                                        lc(:, i) = (2 * Fstar(ld, pi - (kps + kms), -kps_rp, -kms_rm, &
                                                              -(kps_bp + kms_bp), -kms_bpm, -kms_theta) &
                                                        - Arc(ld, -km, -pm1, rm, bm(i), &
                                                              0.d0, -km_rm, -km_bp, -km_bpm, -km_theta, &
                                                              -pm_rp, -pm_rm, -thetam_bp, -pm_bpm - thetam_bpm, -thetam_theta, &
                                                              dbm, .FALSE., .TRUE., .FALSE.) &
                                                        - Arc(ld, -pm2, km, rm, bm(i), &
                                                              pm_rp, pm_rm, -thetam_bp, pm_bpm - thetam_bpm, -thetam_theta, &
                                                              0.d0, km_rm, km_bp, km_bpm, km_theta, &
                                                              dbm, .FALSE., .FALSE., .TRUE.) &
                                                        - Arc(ld, pp1, kp, rp, bp(i), &
                                                              pp_rp, pp_rm, 0.d0, pp_bpm, 1.d0, &
                                                              kp_rp, 0.d0, kp_bp, 0.d0, 0.d0, &
                                                              dbm0, .TRUE., .FALSE., .TRUE.) &
                                                        - Arc(ld, -kp, pp2, rp, bp(i), &
                                                              -kp_rp, 0.d0, -kp_bp, 0.d0, 0.d0, &
                                                              -pp_rp, -pp_rm, 0.d0, -pp_bpm, 1.d0, &
                                                              dbm0, .TRUE., .TRUE., .FALSE.)) * of0
                                    else
                                        ! planet and moon both partially overlap star and each other, 
                                        ! with the planet/moon overlap partially overlapping the star
                                        
                                        ! there might be a mistake somewhere in here... 
                                        phi_bpm = bp(i) * sth(i) / (bm(i) * bm(i))
                                        phi_theta = bpm(i) * (bp(i) * cth(i) - bpm(i)) / (bm(i) * bm(i))
                                        phi_bp = - bpm(i) * sth(i) / (bm(i) * bm(i))
                                        
                                        lc(:, i) = (2 * Fstar(ld, pi - 0.5 * (kps + kms + phi), &
                                                              -0.5 * kps_rp, -0.5 * kms_rm, &
                                                              -0.5 * (kps_bp + kms_bp + phi_bp), -0.5 * (kms_bpm + phi_bpm), &
                                                              -0.5 * (kms_theta + phi_theta)) &
                                                        - Arc(ld, -pm2, km, rm, bm(i), &
                                                              pm_rp, pm_rm, -thetam_bp, pm_bpm - thetam_bpm, -thetam_theta, &
                                                              0.d0, km_rm, km_bp, km_bpm, km_theta,  &
                                                              dbm, .FALSE., .FALSE., .TRUE.) &
                                                        - Arc(ld, -kp, pp2, rp, bp(i), &
                                                              -kp_rp, 0.d0, -kp_bp, 0.d0, 0.d0, &
                                                              -pp_rp, -pp_rm, 0.d0, -pp_bpm, 1.d0, &
                                                              dbm0, .TRUE., .TRUE., .FALSE.)) * of0
                                    end if
                                end if
                            end if
                        end if
                    end if
                end if
            end if  
        end if
        lc(7, i) = lc(7, i) + (lc(1, i) - 1.d0) * pithird * of0
        lc(8, i) = lc(8, i) + (lc(1, i) - 1.d0) * 0.5d0 * pithird * of0
        lc(:, i) = lc(:, i) - f0 * of0
    end do
    return
    
end

! work out the right sign and order of the integration and call the integration routine 
! to integrate along an arbitrary arc of the planet or moon 
function Arc(ld, phi1, phi2, r, b, phi1_rp, phi1_rm, phi1_bp, phi1_bpm, phi1_theta, &
            phi2_rp, phi2_rm, phi2_bp, phi2_bpm, phi2_theta, dbm, pflag, limbflag1, limbflag2)
                    
    real*8, dimension(8) :: Arc

    logical :: pflag, limbflag1, limbflag2
    real*8 :: phi1, phi2, r, b
    real*8, dimension(3) :: ld
    real*8, dimension(3) :: dbm
    real*8 :: phi1_rp, phi1_rm, phi1_bp, phi1_bpm, phi1_theta
    real*8 :: phi2_rp, phi2_rm, phi2_bp, phi2_bpm, phi2_theta
        
    if (phi1 < 0) then
        if (phi2 > 0) then
            Arc = F(ld, phi2, r, b, phi2_rp, phi2_rm, phi2_bp, phi2_bpm, phi2_theta, &
                    dbm, pflag, limbflag2) &
                + F(ld, -phi1, r, b, -phi1_rp, -phi1_rm, -phi1_bp, -phi1_bpm, -phi1_theta, &
                    dbm, pflag, limbflag1)
            return
        else
            if (phi2 < phi1) then
                Arc = 2 * Fcomplete(ld, r, b, dbm, pflag) &
                    + F(ld, -phi1, r, b, -phi1_rp, -phi1_rm, -phi1_bp, -phi1_bpm, -phi1_theta, &
                        dbm, pflag, limbflag1) &
                    - F(ld, -phi2, r, b, -phi2_rp, -phi2_rm, -phi2_bp, -phi2_bpm, -phi2_theta, &
                        dbm, pflag, limbflag2)
                return
            else
                Arc = - F(ld, -phi2, r, b, -phi2_rp, -phi2_rm, -phi2_bp, -phi2_bpm, -phi2_theta, &
                          dbm, pflag, limbflag2) &
                      + F(ld, -phi1, r, b, -phi1_rp, -phi1_rm, -phi1_bp, -phi1_bpm, -phi1_theta, &
                          dbm, pflag, limbflag1)
                return
            end if
        end if
    else
        if (phi2 < 0) then
            Arc = 2 * Fcomplete(ld, r, b, dbm, pflag) &
                - F(ld, phi1, r, b, phi1_rp, phi1_rm, phi1_bp, phi1_bpm, phi1_theta, &
                    dbm, pflag, limbflag1) &
                - F(ld, -phi2, r, b, -phi2_rp, -phi2_rm, -phi2_bp, -phi2_bpm, -phi2_theta, &
                    dbm, pflag, limbflag2)
            return
        else
            if (phi2 < phi1) then
                Arc = 2 * Fcomplete(ld, r, b, dbm, pflag) &
                    + F(ld, phi2, r, b, phi2_rp, phi2_rm, phi2_bp, phi2_bpm, phi2_theta, &
                        dbm, pflag, limbflag2) &
                    - F(ld, phi1, r, b, phi1_rp, phi1_rm, phi1_bp, phi1_bpm, phi1_theta, &
                        dbm, pflag, limbflag1)
                return
            else
                Arc = F(ld, phi2, r, b, phi2_rp, phi2_rm, phi2_bp, phi2_bpm, phi2_theta, &
                        dbm, pflag, limbflag2) &
                    - F(ld, phi1, r, b, phi1_rp, phi1_rm, phi1_bp, phi1_bpm, phi1_theta, &
                        dbm, pflag, limbflag1)
                return
            end if
        end if
    end if
    
    return
    
end function

! integrate along the limb of the star
function Fstar(ld, phi, phi_rp, phi_rm, phi_bp, phi_bpm, phi_theta)

    real*8, dimension(8) :: Fstar
    real*8, dimension(3) :: F_, F_rp, F_rm, F_bp, F_bpm, F_theta

    real*8 :: phi
    real*8 :: Fc_phi, Fq_phi, Fl_phi
    real*8 :: phi_bp, phi_rp, phi_rm, phi_bpm, phi_theta
    real*8, dimension(3) :: ld
        
    F_(1) = 0.5 * phi
    Fc_phi = 0.5
    F_rp(1) = Fc_phi * phi_rp
    F_rm(1) = Fc_phi * phi_rm
    F_bp(1) = Fc_phi * phi_bp
    F_bpm(1) = Fc_phi * phi_bpm
    F_theta(1) = Fc_phi * phi_theta
    
    F_(2) = phi * o3
    Fl_phi = o3
    F_rp(2) = Fl_phi * phi_rp
    F_rm(2) = Fl_phi * phi_rm
    F_bp(2) = Fl_phi * phi_bp
    F_bpm(2) = Fl_phi * phi_bpm
    F_theta(2) = Fl_phi * phi_theta

    F_(3) = 0.25 * phi
    Fq_phi = 0.25d0
    F_rp(3) = Fq_phi * phi_rp
    F_rm(3) = Fq_phi * phi_rm
    F_bp(3) = Fq_phi * phi_bp
    F_bpm(3) = Fq_phi * phi_bpm
    F_theta(3) = Fq_phi * phi_theta
    
    Fstar(1) = Sum(ld * F_)
    Fstar(2) = Sum(ld * F_rp)
    Fstar(3) = Sum(ld * F_rm)
    Fstar(4) = Sum(ld * F_bp)
    Fstar(5) = Sum(ld * F_bpm)
    Fstar(6) = Sum(ld * F_theta)
    Fstar(7) = - F_(1) + F_(2)
    Fstar(8) = -2 * F_(1) + 2 * F_(2) + F_(3)
    return
    
end function

! integrate around the entire planet/moon 
function Fcomplete(ld, r, b, dbm, pflag)

    real*8, dimension(8) :: Fcomplete
    real*8, dimension(3) :: F_, F_r, F_b
    real*8 :: sumF_b
    
    ! Are we integrating along the edge of the moon or the planet? 
    logical :: pflag
    
    ! Limb darkening params
    real*8, dimension(3) :: ld
    
    ! self explanatory
    real*8 :: r, b
    
    ! derivatives of input parameters 
    real*8, dimension(3) :: dbm
    
    ! convenient parameters
    real*8 :: r2, b2, br, bmr, bpr, obmr
    real*8 :: x, ox, o
    
    ! For the integral
    real*8 :: alpha, beta, gamma, n, m
    real*8 :: sgn
    real*8 :: ur, ub, vb, sqomm
    
    ! Elliptic integrals
    real*8 :: ellippi, ellipe, ellipf
    real*8 :: eplusf, eplusf_r, eplusf_b
    
    r2 = r * r
    b2 = b * b
    bmr = b - r
    obmr = 1.d0 / bmr
    bpr = b + r
    br = b * r
    
    F_(1) = r2 * pihalf  
    F_r(1) = r * pi
    F_b(1) = 0.d0
    
    F_(3) = pihalf * r2 * (b2 + 0.5 * r2) 
    F_r(3) = pi * r * (b2 + r2)
    F_b(3) = pi * r2 * b

    x = Sqrt((1.d0 - bmr) * (1.d0 + bmr))
    ox = 1.d0 / x
            
    alpha = (7 * r2 + b2 - 4.d0) * o9 * x
    beta = (r2 * r2 + b2 * b2 + r2 - b2 * (5.d0 + 2 * r2) + 1.d0) * o9 * ox        
            
    n = -4 * br * obmr * obmr
    m = 4 * br * ox * ox
            
    ur = 2 * r * x
    ub = x * ((b + 1.d0) * (b - 1.d0) + r2) / (3 * b)
    vb = ((-1.d0 + b2)**2.d0 - 2 * (1.d0 + b2) * r2 + r2 * r2) * o3 * ox / b
            
    sqomm = Sqrt(1.d0 - m)
    o = 1.d0
            
    if (b .eq. r) then 
        ellippi = 0.d0
        sgn = 0.d0
        gamma = 0.d0
    else
        ellippi = cel((sqomm), (1.d0 - n), (o), (o))
        sgn = Sign(1.d0, bmr)
        gamma = bpr * ox * o3 * obmr
    end if 
            
    ellipe = cel((sqomm), (o), (o), 1.d0 - m)
    ellipf = cel((sqomm), (o), (o), (o))
             
    eplusf = alpha * ellipe + beta * ellipf
    eplusf_r = ur * ellipe
    eplusf_b = ub * ellipe + vb * ellipf
            
    F_(2) = eplusf + gamma * ellippi + pisixth * (1.d0 - sgn)
    F_r(2) = eplusf_r
    F_b(2) = eplusf_b

    Fcomplete = 0.d0
    sumF_b = Sum(ld * F_b)
    
    if (pflag) then
        Fcomplete(1) = Sum(ld * F_)
        Fcomplete(2) = Sum(ld * F_r)
        Fcomplete(4) = Sum(ld * F_b)
        Fcomplete(7) = - F_(1) + F_(2)
        Fcomplete(8) = -2 * F_(1) + 2 * F_(2) + F_(3)
    else
        Fcomplete(1) = Sum(ld * F_)
        Fcomplete(3) = Sum(ld * F_r)
        Fcomplete(4) = sumF_b * dbm(1)
        Fcomplete(5) = sumF_b * dbm(2)
        Fcomplete(6) = sumF_b * dbm(3)
        Fcomplete(7) = - F_(1) + F_(2)
        Fcomplete(8) = -2 * F_(1) + 2 * F_(2) + F_(3)
    end if
    return

end function

! evaluate the integral at one arbitrary limit along the planet or moon's boundary 
function F(ld, phi, r, b, phi_rp, phi_rm, phi_bp, phi_bpm, phi_theta, dbm, pflag, limbflag)

    real*8, dimension(8) :: F
    real*8, dimension(3) :: F_, F_rp, F_rm, F_bp, F_bpm, F_theta
    
    ! Are we integrating along the edge of the moon or the planet? 
    logical :: pflag, limbflag
    
    ! Limb darkening params
    real*8, dimension(3) :: ld
    
    ! self explanatory
    real*8 :: phi, r, b
    
    ! derivatives of input parameters 
    real*8 :: phi_bp, phi_rp, phi_rm, phi_bpm, phi_theta
    real*8, dimension(3) :: dbm
    
    ! convenient parameters
    real*8 :: sphi, cphi, tphihalf, sphihalf, cphihalf
    real*8 :: r2, b2, br, bmr, bpr, obmr
    real*8 :: x, y, z, ox, oy, oz, tans, o
    
    ! components of flux and their derivatives
    real*8 :: Fc_phi, Fc_r, Fc_b
    real*8 :: Fq_phi, Fq_r, Fq_b
    real*8 :: Fl_phi, Fl_r, Fl_b
    
    ! For the integral
    real*8 :: alpha, beta, gamma, d, n, m
    real*8 :: ur, vr, ub, vb, pr, pb, sqomm
    
    ! Elliptic integrals
    real*8 :: ellippi, ellipe, ellipf
    real*8 :: eplusf, eplusf_r, eplusf_b
    
    r2 = r * r
    b2 = b * b
    bmr = b - r
    obmr = 1.d0 / bmr
    bpr = b + r
    br = b * r
    
    cphi = Cos(phi)
    sphi = Sin(phi)
    sphihalf = Sin(phi * 0.5)
    cphihalf = Cos(phi * 0.5)
    tphihalf = sphihalf / cphihalf
    
    if (phi .eq. pi) then
        F = Fcomplete(ld, r, b, dbm, pflag)
        return
    end if
        
    F_(1) = 0.5 * (r2 * phi - br * sphi)
    Fc_phi = 0.5 * (r2 - br * cphi)
    Fc_b = -0.5 * r * sphi
    Fc_r = 0.5 * (2 * r * phi - b * sphi)
    
    F_rp(1) = Fc_phi * phi_rp
    F_rm(1) = Fc_phi * phi_rm
    F_bp(1) = Fc_phi * phi_bp
    F_bpm(1) = Fc_phi * phi_bpm
    F_theta(1) = Fc_phi * phi_theta
    
    F_(3) = 0.25 * (r * (r * (2 * b2 + r2) * phi &
          + b * (-b2 - 3 * r2 + br * cphi) * sphi))
    Fq_phi = 0.25 * (r * (2 * b2 * r + r2 * r + b * (-((b2 + 3 * r2) * cphi) &
           + br * (1.d0 - 2 * sphi * sphi))))
    Fq_r = r * (b2 + r2) * phi - 0.25 * (b * (b2 + 9 * r2 - 2 * br * cphi) * sphi)
    Fq_b = 0.25 * (r * (-3 * (b2 + r2) * sphi + br * (4 * phi + 2 * sphi * cphi)))
                
    F_rp(3) = Fq_phi * phi_rp
    F_rm(3) = Fq_phi * phi_rm
    F_bp(3) = Fq_phi * phi_bp
    F_bpm(3) = Fq_phi * phi_bpm
    F_theta(3) = Fq_phi * phi_theta
    
    y = Sqrt(br)
    oy = 1.d0 / y
    x = b2 + r2 - 2 * br * cphi
    ox = 1.d0 / x

    pr = - b * sphi * o3 * ox
    pb = r * sphi * o3 * ox
    
    if (bpr .gt. 1.d0) then
            
        alpha = 2 * y * (7 * r2 + b2 - 4.d0) * o9
        beta = -(3.d0 + 2*r*(b2 * b + 5 * b2 * r + 3*r*(-2.d0 + r2) + b*(-4.d0 + 7*r2))) * o9 * 0.5 * oy
        gamma = bpr * o3 * 0.5 * oy * obmr
            
        m = (1.d0 - bmr) * (1.d0 + bmr) * 0.25 * oy * oy
        n = ((bmr + 1.d0) * (bmr - 1.d0)) * obmr * obmr
        sqomm = Sqrt(1.d0 - m)

        ur = 4 * r * y
        vr = - r * (bpr + 1.d0) * (bpr - 1.d0) * oy
        ub = 2 * r * (b2 + r2 - 1.d0) * o3 * oy
        vb = vr * o3
            
        if (limbflag) then
            
            d = phi * o3 * 0.5 - Atan(bpr * tphihalf * obmr) * o3
            Fl_phi = (r2 - br * cphi) * o3 * ox
                
            o = 1.d0
            ellippi = cel((sqomm), 1.d0 - n, (o), (o))
            ellipe = cel((sqomm), (o), (o), (1.d0 - m))
            ellipf = cel((sqomm), (o), (o), (o))
                
            eplusf = alpha * ellipe + beta * ellipf
            eplusf_r = ur * ellipe + vr * ellipf
            eplusf_b = ub * ellipe + vb * ellipf
                
        else   
            
            z = Sqrt(1.d0 - x)
            oz = 1.d0 / z
            d = o3 * (phi * 0.5 - Atan(bpr * tphihalf * obmr)) &
                - (2 * br * o9) * sphi * z

            Fl_phi = o3 * (1.d0 - z ** 3.d0) * (r2 - br * cphi) * ox

            pr = - ((1.d0 - x)**(1.5d0) - 1.d0) * pr
            pb = (1.d0 - (1.d0 + x) * Sqrt(1.d0 - x)) * pb
                                        
            tans = 1.d0 / Sqrt(m / (sphihalf * sphihalf) - 1.d0)
            o = 1.d0
            ellippi = el3((tans), (sqomm), 1.d0 - n)
            ellipe = el2((tans), (sqomm), (o), (1.d0 - m))
            ellipf = el2((tans), (sqomm), (o), (o))
                
            eplusf = alpha * ellipe + beta * ellipf
            eplusf_r = ur * ellipe + vr * ellipf
            eplusf_b = ub * ellipe + vb * ellipf

        end if
        F_(2) = eplusf + gamma * ellippi + d
        Fl_r = eplusf_r + pr
        Fl_b = eplusf_b + pb
            
    else
        
        y = Sqrt((1.d0 - bmr) * (1.d0 + bmr))
        oy = 1.d0 / y
            
        alpha = (7 * r2 + b2 - 4.d0) * y * o9
        beta = (r2 * r2 + b2 * b2 + r2 - b2 * (5.d0 + 2 * r2) + 1.d0) * o9 * oy
        gamma = bpr * o3 * oy * obmr
                        
        n = -4 * br * obmr * obmr
        m = 4 * br * oy * oy
            
        sqomm = Sqrt(1.d0 - m)
            
        pr = - ((1.d0 - x)**(1.5d0) - 1.d0) * pr
        pb = (1.d0 - (1.d0 + x) * Sqrt(1.d0 - x)) * pb
            
        ur = 2 * r * y
        ub = y * ((b + 1.d0) * (b - 1.d0) + r2) / (3 * b)
        vb = (b2 * b2 + ((r - 1.d0) * (r + 1.d0))**2.d0 - 2 * b2 * (1.d0 + r2)) / (3 * b * y) 
            
        d = o3 * (phi * 0.5 - Atan(bpr * tphihalf * obmr)) &
            - 2 * br * o9 * sphi * Sqrt(1.d0 - x)
             
        o = 1.d0
        ellipe = el2((tphihalf), (sqomm), (o), (1.d0 - m))
        ellipf = el2((tphihalf), (sqomm), (o), (o))
            
        if (b .eq. r) then
            Fl_phi = o3 * (1.d0 - (1.d0 - x) ** 1.5d0) * (r2 - br * cphi) * ox
            ellippi = 0.d0
            gamma = 0.d0
        else
            Fl_phi = o3 * (1.d0 - (1.d0 - x) ** 1.5d0) * (r2 - br * cphi) * ox
            ellippi = el3((tphihalf), (sqomm), (1.d0 - n))
        end if
                
        eplusf = alpha * ellipe + beta * ellipf
        eplusf_r = ur * ellipe
        eplusf_b = ub * ellipe + vb * ellipf 
            
        F_(2) = eplusf + gamma * ellippi + d
        Fl_r = eplusf_r + pr
        Fl_b = eplusf_b + pb
    end if
                
    F_rp(2) = Fl_phi * phi_rp
    F_rm(2) = Fl_phi * phi_rm
    F_bp(2) = Fl_phi * phi_bp
    F_bpm(2) = Fl_phi * phi_bpm
    F_theta(2) = Fl_phi * phi_theta
    
    if (pflag) then
        F_bp(3) = F_bp(3) + Fq_b
        F_rp(3) = F_rp(3) + Fq_r
        
        F_bp(1) = F_bp(1) + Fc_b
        F_rp(1) = F_rp(1) + Fc_r
        
        F_bp(2) = F_bp(2) + Fl_b
        F_rp(2) = F_rp(2) + Fl_r
    else
        F_theta(3) = F_theta(3) + Fq_b * dbm(3)
        F_bpm(3) = F_bpm(3) + Fq_b * dbm(2)
        F_bp(3) = F_bp(3) + Fq_b * dbm(1)
        F_rm(3) = F_rm(3) + Fq_r
        
        F_theta(1) = F_theta(1) + Fc_b * dbm(3)
        F_bpm(1) = F_bpm(1) + Fc_b * dbm(2)
        F_bp(1) = F_bp(1) + Fc_b * dbm(1)
        F_rm(1) = F_rm(1) + Fc_r
        
        F_theta(2) = F_theta(2) + Fl_b * dbm(3)
        F_bpm(2) = F_bpm(2) + Fl_b * dbm(2)
        F_bp(2) = F_bp(2) + Fl_b * dbm(1)
        F_rm(2) = F_rm(2) + Fl_r
    end if
    
    F(1) = Sum(ld * F_)
    F(2) = Sum(ld * F_rp)
    F(3) = Sum(ld * F_rm)
    F(4) = Sum(ld * F_bp)
    F(5) = Sum(ld * F_bpm)
    F(6) = Sum(ld * F_theta)
    F(7) = - F_(1) + F_(2)
    F(8) = -2 * F_(1) + 2 * F_(2) + F_(3)

    return
end function

end module phot

module hrch
use kepler
use iso_c_binding
implicit none

contains

subroutine coords(t, ap, t0p, ep, Pp, wp, ip, am, &
    &t0m, em, Pm, Om, wm, im, mm, j, &
    &xp, yp, zp, xm, ym, zm) bind(C, name="coords")
    
    integer (c_int), bind(C) :: j
    real*8 :: np, nm
    real*8 :: mrp, mrm, comegam, somegam
    real*8 :: cwp, swp, cip, cwm, swm, cim
    real*8, dimension(j) :: x, y, z, xbc, ybc, zbc
    real*8, dimension(j) :: r, cosf, sinf, cosfw, sinfw
    real (c_double), bind(C) :: ap, t0p, ep, Pp, wp, ip, am 
    real (c_double), bind(C) :: t0m, em, Pm, Om, wm, im, mm
    real (c_double), bind(C), dimension(j) :: t
    real (c_double), bind(C), dimension(j), intent(out) :: xp, yp, zp, xm, ym, zm
            
    np = 2 * pi / Pp    
    nm = 2 * pi / Pm

    cwp = Cos(wp)
    swp = Sin(wp)
    cip = Cos(ip)
    
    comegam = Cos(Om)
    somegam = Sin(Om)
    cwm = Cos(wm)
    swm = Sin(wm)
    cim = Cos(im)

    mrp = - 1.d0 / (1.d0 + mm)
    mrm = - mm * mrp
    
    call kepler_solve_RPP(np * (t - t0p), ep, cosf, sinf, j)
    
    r = ap * (1.d0 - ep * ep) / (1.d0 + ep * cosf)
    cosfw = cwp * cosf - swp * sinf
    sinfw = swp * cosf + sinf * cwp
    xbc = -r * cosfw
    ybc = -r * sinfw * cip
    zbc = r * sinfw * Sin(ip)
    
    call kepler_solve_RPP(nm * (t - t0m), em, cosf, sinf, j)
    
    r = am * (1.d0 - em * em) / (1.d0 + em * cosf)
    cosfw = cwm * cosf - swm * sinf
    sinfw = swm * cosf + sinf * cwm
    x = -r * (comegam * cosfw - somegam * sinfw * cim)
    y = -r * (somegam * cosfw + comegam * sinfw * cim)
    z = r * sinfw * Sin(im)
        
    xp = xbc + x * mrm
    yp = ybc + y * mrm
    zp = zbc + z * mrm

    xm = xbc + x * mrp
    ym = ybc + y * mrp
    zm = zbc + z * mrp
    
end

subroutine grad_coords(t, ap, t0p, ep, Pp, wp, ip, am, &
    &t0m, em, Pm, Om, wm, im, mm, j, &
    &xp, yp, xm, ym, dxp, dyp, dxm, dym) bind(C, name="grad_coords")

    integer (c_int), bind(C) :: j
    real*8 :: np, nm
    real*8 :: mrp, mrm, comegam, somegam
    real*8 :: cwp, swp, cip, cwm, swm, cim, sip, sim
    real*8, dimension(j) :: x, y, xbc, ybc
    real*8, dimension(j) :: r, cosf, sinf, cosfw, sinfw, denom
    real (c_double), bind(C) :: ap, t0p, ep, Pp, wp, ip, am 
    real (c_double), bind(C) :: t0m, em, Pm, Om, wm, im, mm
    real (c_double), bind(C), dimension(j) :: t
    real (c_double), bind(C), dimension(j), intent(out) :: xp, yp, xm, ym
    
    real (c_double), bind(C), dimension(j, 14), intent(out) :: dxp, dyp, dxm, dym
    real*8, dimension(j) :: xbc_a, ybc_a, x_a, y_a
    
    real*8 :: np_Pp, nm_Pm
    real*8 :: np_ms, np_mp, np_mm, nm_mp, nm_mm
    real*8 :: mrp_mm, mrm_mm, mp
    real*8, dimension(j) :: r_t0, r_e, r_cosf
    real*8, dimension(j) :: f_M, f_e
    real*8, dimension(j) :: ccmss, cspsc, scpcs, ssmcc
    real*8, dimension(j) :: r_Pp, r_Pm
        
    np = 2 * pi / Pp
    np_Pp = -np / Pp
    
    nm = 2 * pi / Pm
    nm_Pm = -nm / Pm
    
    cwp = Cos(wp)
    swp = Sin(wp)
    cip = Cos(ip)
    sip = Sin(ip)
    
    comegam = Cos(Om)
    somegam = Sin(Om)
    cwm = Cos(wm)
    swm = Sin(wm)
    cim = Cos(im)
    sim = Sin(im)

    mrp = - 1.d0 / (1.d0 + mm)
    mrm = - mm * mrp
    
    mrp_mm = - mrp / (1.d0 + mm)
    mrm_mm = mrp_mm
    
    mp = 1.d0 / mm
    
    call grad_kepler_solve_RPP(np * (t - t0p), ep, cosf, sinf, f_e, f_M, j)
    
    denom = 1.d0 / (1.d0 + ep * cosf)
    r = ap * (1.d0 - ep * ep) * denom
    r_cosf = - r * ep * denom
    r_t0 = r_cosf * sinf * f_M * np
    r_e = -r_cosf * sinf * f_e - ap * (cosf + 2 * ep + cosf * ep * ep) * denom * denom
    r_Pp = -r_cosf * sinf * f_M * (t - t0p) * np_Pp
     
    cosfw = cwp * cosf - swp * sinf
    sinfw = swp * cosf + sinf * cwp
    
    ccmss = cosfw
    cspsc = sinfw
    scpcs = sinfw * cip
    ssmcc = - cosfw * cip
    xbc = -r * ccmss
    xbc_a = - r * ccmss / ap
    ybc = -r * scpcs
    ybc_a = - r * scpcs / ap
    
    dxp(:, 1) = xbc_a
    dxm(:, 1) = xbc_a
    dxp(:, 2) = - r_t0 * ccmss - r * f_M * np * cspsc
    dxm(:, 2) = dxp(:, 2)
    dxp(:, 3) = - r_e * ccmss + r * f_e * cspsc
    dxm(:, 3) = dxp(:, 3)
    dxp(:, 4) = - r_Pp * ccmss + r * f_M * (t - t0p) * np_Pp * cspsc
    dxm(:, 4) = dxp(:, 4)
    dxp(:, 5) = r * cspsc
    dxm(:, 5) = dxp(:, 5)
    dxp(:, 6) = 0.d0
    dxm(:, 6) = 0.d0
        
    ! ms
    dyp(:, 1) = ybc_a
    dym(:, 1) = ybc_a
    ! t0p
    dyp(:, 2) = - r_t0 * scpcs - r * f_M * np * ssmcc
    dym(:, 2) = dyp(:, 2)
    ! ep
    dyp(:, 3) = - r_e * scpcs + r * f_e * ssmcc
    dym(:, 3) = dyp(:, 3)
    ! Pp
    dyp(:, 4) = - r_Pp * scpcs + r * f_M * (t - t0p) * np_Pp * ssmcc
    dym(:, 4) = dyp(:, 4)
    ! wp
    dyp(:, 5) = r * ssmcc
    dym(:, 5) = dyp(:, 5)
    ! ip
    dyp(:, 6) = r * sinfw * sip
    dym(:, 6) = dyp(:, 6)
    
    call grad_kepler_solve_RPP(nm * (t - t0m), em, cosf, sinf, f_e, f_M, j)
    
    denom = 1.d0 / (1.d0 + em * cosf)
    r = am * (1.d0 - em * em) * denom
    r_cosf = - em * r * denom
    r_t0 = r_cosf * sinf * f_M * nm
    r_e = -r_cosf * sinf * f_e - am * (cosf + 2 * em + cosf * em * em) * denom * denom
    r_Pm = -r_cosf * sinf * f_M * (t - t0m) * nm_Pm
     
    cosfw = cwm * cosf - swm * sinf
    sinfw = swm * cosf + sinf * cwm
    
    ccmss = comegam * cosfw - somegam * sinfw * cim
    cspsc = comegam * sinfw + somegam * cosfw * cim
    scpcs = somegam * cosfw + comegam * sinfw * cim
    ssmcc = somegam * sinfw - comegam * cosfw * cim
    x = -r * ccmss
    x_a = -r * ccmss / am
    y = -r * scpcs
    y_a = -r * scpcs / am
        
    ! ms, t0p, ep, Pp, Op, wp, ip, mp, t0m, em, Pm, wm, Om, im, mm
    xp = xbc + x * mrm
    
    dxp(:, 7) = x_a * mrm
    dxp(:, 8) = (- r_t0 * ccmss - r * f_M * nm * cspsc) * mrm
    dxp(:, 9) = (- r_e * ccmss + r * f_e * cspsc) * mrm
    dxp(:, 10) = (- r_Pm * ccmss + r * f_M * (t - t0m) * nm_Pm * cspsc) * mrm
    dxp(:, 11) = r * scpcs * mrm
    dxp(:, 12) = r * cspsc * mrm
    dxp(:, 13) = -r * somegam * sinfw * sim * mrm
    dxp(:, 14) = x * mrm_mm
    
    yp = ybc + y * mrm

    dyp(:, 7) = y_a * mrm
    dyp(:, 8) = (- r_t0 * scpcs - r * f_M * nm * ssmcc) * mrm
    dyp(:, 9) = (- r_e * scpcs + r * f_e * ssmcc) * mrm
    dyp(:, 10) = (- r_Pm * scpcs + r * f_M * (t - t0m) * nm_Pm * ssmcc) * mrm
    dyp(:, 11) = -r * ccmss * mrm
    dyp(:, 12) = r * ssmcc * mrm
    dyp(:, 13) = r * comegam * sinfw * sim * mrm
    dyp(:, 14) = y * mrm_mm

    xm = xbc + x * mrp

    dxm(:, 7) = x_a * mrp
    dxm(:, 8) = -dxp(:, 8) * mp
    dxm(:, 9) = -dxp(:, 9) * mp
    dxm(:, 10) = -dxp(:, 10) * mp
    dxm(:, 11) = -dxp(:, 11) * mp
    dxm(:, 12) = -dxp(:, 12) * mp
    dxm(:, 13) = -dxp(:, 13) * mp
    dxm(:, 14) = x * mrp_mm
    
    ym = ybc + y * mrp

    dym(:, 7) = y_a * mrp
    dym(:, 8) = -dyp(:, 8) * mp
    dym(:, 9) = -dyp(:, 9) * mp
    dym(:, 10) = -dyp(:, 10) * mp
    dym(:, 11) = -dyp(:, 11) * mp
    dym(:, 12) = -dyp(:, 12) * mp
    dym(:, 13) = -dyp(:, 13) * mp
    dym(:, 14) = y * mrp_mm
    
end

subroutine grad_impacts(t, ap, t0p, ep, Pp, wp, ip, am, &
    &t0m, em, Pm, Om, wm, im, mm, j, &
    &bp, bpm, theta, dbp, dbpm, dtheta) bind(C, name="grad_impacts")

    integer :: i
    real*8 :: a, b, c, tmp, mu
    real*8, dimension(j) :: bm, bm2, bp2, bpm2, sth
    real*8, dimension(j) :: xp, yp, xm, ym
    real*8, dimension(j) :: bm_xm, bm_ym, bp_xp, bp_yp, bpm_xm, bpm_ym, bpm_xp, bpm_yp
    real*8, dimension(j) :: theta_bp, theta_bpm, theta_bm, denom
    real*8, dimension(j, 14) :: dxp, dyp, dxm, dym, dbm
    integer (c_int), bind(C) :: j
    real (c_double), bind(C) :: ap, t0p, ep, Pp, wp, ip, am 
    real (c_double), bind(C) :: t0m, em, Pm, Om, wm, im, mm
    real (c_double), bind(C), dimension(j) :: t
    real (c_double), bind(C), intent(out), dimension(j) :: bp, bpm, theta
    real (c_double), bind(C), intent(out), dimension(j, 14) :: dbp, dbpm, dtheta
    
    call grad_coords(t, ap, t0p, ep, Pp, wp, ip, am, t0m, em, &
                Pm, Om, wm, im, mm, j, xp, yp, xm, ym, &
                dxp, dyp, dxm, dym)
        
    bm2 = xm**2.d0 + ym**2.d0
    bm = Sqrt(bm2)
    bm_xm = xm / bm
    bm_ym = ym / bm
    
    bp2 = xp**2.d0 + yp**2.d0
    bp = Sqrt(bp2)
    bp_xp = xp / bp
    bp_yp = yp / bp
    
    bpm2 = (xm - xp)**2.d0 + (ym - yp)**2.d0
    bpm = Sqrt(bpm2)
    bpm_xm = (xm - xp) / bpm
    bpm_ym = (ym - yp) / bpm
    bpm_xp = - bpm_xm
    bpm_yp = - bpm_ym
    
    do i=1,j,1
    
        a = bp(i) 
        b = bpm(i)
        c = bm(i)
        
        if (a .GT. b) then
            tmp = b
            b = a
            a = tmp
        end if
        if (b .GT. c) then
            mu = c - (a - b)
        else
            mu = b - (a - c)
        end if
            
        if ((bpm(i) .lt. 1.d-15) .or. ((a - b + c) .lt. 1.d-15)) then
            theta(i) = 0.d0
        else if ((a - c + b) .lt. 1.d-15) then 
            theta(i) = pi
        else
            theta(i) = 2 * Atan(Sqrt(((a - b) + c) * mu / ((a + (b + c)) * ((a - c) + b))))
        end if
        
        sth(i) = Sin(theta(i))
        if (abs(sth(i)) .lt. 1.d-15) then 
            theta_bm(i) = 0.d0
            theta_bp(i) = 0.d0
            theta_bpm(i) = 0.d0
        else
            denom(i) = 1.d0 / (bp2(i) * bpm2(i) * sth(i))
            theta_bm(i) = bm(i) * bp(i) * bpm(i) * denom(i)
            theta_bp(i) = ((bpm(i) - bm(i)) * (bpm(i) + bm(i)) - bp2(i)) * 0.5 * bpm(i) * denom(i)
            theta_bpm(i) = ((bp(i) - bm(i)) * (bp(i) + bm(i)) - bpm2(i)) * 0.5 * bp(i) * denom(i)
        end if 
        
    end do
    
    do i=1,14,1
        dbm(:, i) = bm_xm * dxm(:, i) + bm_ym * dym(:, i)
        dbp(:, i) = bp_xp * dxp(:, i) + bp_yp * dyp(:, i)
        dbpm(:, i) = bpm_xm * dxm(:, i) + bpm_ym * dym(:, i) &
                   + bpm_xp * dxp(:, i) + bpm_yp * dyp(:, i)
        dtheta(:, i) = theta_bm * dbm(:, i) &
                     + theta_bp * dbp(:, i) &
                     + theta_bpm * dbpm(:, i)
    end do

    bp = bp
    bpm = bpm
    dbp = dbp
    dbpm = dbpm
            
end

subroutine impacts(t, ap, t0p, ep, Pp, wp, ip, am, &
    &t0m, em, Pm, Om, wm, im, mm, j, bp, bpm, theta) bind(C, name="impacts")

    integer :: i
    real*8 :: a, b, c, tmp, mu
    real*8, dimension(j) :: bm, bm2, bp2, bpm2
    real*8, dimension(j) :: xp, yp, xm, ym, zp, zm
    integer (c_int), bind(C) :: j
    real (c_double), bind(C) :: ap, t0p, ep, Pp, wp, ip, am 
    real (c_double), bind(C) :: t0m, em, Pm, Om, wm, im, mm
    real (c_double), bind(C), dimension(j) :: t
    real (c_double), bind(C), intent(out), dimension(j) :: bp, bpm, theta
    
    call coords(t, ap, t0p, ep, Pp, wp, ip, am, t0m, em, &
                Pm, Om, wm, im, mm, j, xp, yp, zp, xm, ym, zm)
    
    bm2 = xm**2.d0 + ym**2.d0
    bm = Sqrt(bm2)
    
    bp2 = xp**2.d0 + yp**2.d0
    bp = Sqrt(bp2)
    
    bpm2 = (xm - xp)**2.d0 + (ym - yp)**2.d0
    bpm = Sqrt(bpm2)
    
    do i=1,j,1
    
        a = bp(i) 
        b = bpm(i)
        c = bm(i)
        
        if (a .gt. b) then
            tmp = b
            b = a
            a = tmp
        end if
        if (b .gt. c) then
            mu = c - (a - b)
        else
            mu = b - (a - c)
        end if
        
        if ((bpm(i) .lt. 1.d-15) .or. ((a - b + c) .lt. 1.d-15)) then
            theta(i) = 0.d0
        else if ((a - c + b) .lt. 1.d-15) then 
            theta(i) = pi
        else
            theta(i) = 2 * Atan(Sqrt(((a - b) + c) * mu / ((a + (b + c)) * ((a - c) + b))))
        end if
    end do

    bp = bp
    bpm = bpm
            
end

end

module kepler_tmp
use iso_c_binding
implicit none

real*8, parameter :: pi = 4.d0 * Atan(1.d0), G = 8.887692445125634d-10
real*8, parameter :: o3 = 1.d0 / 3.d0, o6 = 1.d0 / 6.d0, pi_o12 = Atan(1.d0) / 3.d0
real*8, parameter :: au_rsun = 215.03215567054764
real*8, parameter :: if3 = 1.d0 / 6.d0, if5 = 1.d0 / (6.d0 * 20), if7 = 1.d0 / (6.d0 * 20 * 42)
real*8, parameter :: if9 = 1.d0 / (6.d0 * 20 * 42 * 72), if11 = 1.d0 / (6.d0 * 20 * 42 * 72 * 110)
real*8, parameter :: if13 = 1.d0 / (6.d0 * 20 * 42 * 72 * 110 * 156), if15 = 1.d0 / (6.d0 * 20 * 42 * 72 * 110 * 156 * 210)

contains

subroutine kepler_solve(M, ecc, cosf, sinf, j) bind(C, name="kepler_solve")

    integer :: j, i
    real*8 :: tol, err, x, ecc
    real (c_double), bind(C), dimension(j) :: M
    real (c_double), bind(C), dimension(j), intent(out) :: cosf, sinf
    real*8, dimension(j) :: tanfhalf, tanfhalf2, denom, E, sE, cE
    
    if (ecc .lt. 1.d-10) then
        cE = Cos(M)
        sE = Sin(M)
        
        tanfhalf = sE / (1.d0 + cE)
        tanfhalf2 = tanfhalf * tanfhalf
        denom = 1.d0 / (tanfhalf2 + 1.d0)
        cosf = (1.d0 - tanfhalf2) * denom
        sinf = 2 * tanfhalf * denom
    else
        tol = 1.d-15
        
        E = M
        x = Sqrt((1.d0 + ecc) / (1.d0 - ecc))
        
        do i=1,j,1
            err = 1.d0
            do while (abs(err) .gt. tol)
                err = - (E(i) - ecc * Sin(E(i)) - M(i)) / (1.d0 - ecc * Cos(E(i)))
                E(i) = E(i) + err
            end do
        end do    
        
        cE = Cos(E)
        tanfhalf = x * Sin(E) / (1.d0 + cE)
        tanfhalf2 = tanfhalf * tanfhalf
        denom = 1.d0 / (tanfhalf2 + 1.d0)
        cosf = (1.d0 - tanfhalf2) * denom
        sinf = 2 * tanfhalf * denom
    end if
end

function sine(x)

    real*8 :: sine
    real*8 :: x, x2
    
    x2 = x * x
    
    sine = x * (1.d0 - x2 * (if3 - &
                    x2 * (if5 - x2 * (if7 - x2 * (if9 - x2 * (if11 - x2 * (if13 - x2 * if15)))))))

end 

! copied from DFM's exoplanet code
function EAstart(M, ecc)

    real*8 :: EAstart
    real*8 :: M, ecc
    real*8 :: ome, sqrt_ome, chi, Lam, S, sigma, s2, s4, denom, E
    
    ome = 1.d0 - ecc
    sqrt_ome = Sqrt(ome)
    chi = M / (sqrt_ome * ome)
    Lam = Sqrt(8.d0 + 9 * chi * chi)
    S = (Lam + 3 * chi) ** (1.d0 / 3.d0)
    sigma = 6 * chi / (2.d0 + S * S + 4.d0 / (S * S))
    s2 = sigma * sigma
    s4 = s2 * s2
    
    denom = 1.d0 / (s2 + 2.d0)
    E = sigma * (1.d0 + s2 * ome * denom * ((s2 + 20.d0) / 60.d0 &
        + s2 * ome * denom * denom * (s2 * s4 + 25 * s4 + 340 * s2 + 840) / 1400))
    EAstart = E * sqrt_ome
end

! pretty much verbatim from DFM's exoplanet code 
subroutine kepler_solve_RPP(M, ecc, cosf, sinf, j) bind(C, name="kepler_solve_RPP")

    integer, bind(C) :: j
    integer :: i, k
    real*8, bind(C) :: ecc
    real*8, dimension(j), bind(C) :: M, cosf, sinf 
    real*8, dimension(j) :: tanfhalf, tanfhalf2, d
    real*8 :: g2s_e, g3s_e, g4s_e, g5s_e, g6s_e
    real*8, dimension(0:12) :: bounds
    real*8, dimension(0:8) :: EA_tab
    real*8 :: MA, EA, sE, cE, x, y
    real*8 :: B0, B1, B2, dx, idx
    integer :: MAsign, sig
    real*8 :: over_ecc
    real*8 :: num, denom, dEA
    
    g2s_e = 0.2588190451025207623489 * ecc
    g3s_e = 0.5 * ecc
    g4s_e = 0.7071067811865475244008 * ecc
    g5s_e = 0.8660254037844386467637 * ecc
    g6s_e = 0.9659258262890682867497 * ecc
    
    bounds(0) = 0.d0
    bounds(1) = pi_o12 - g2s_e
    bounds(2) = pi * o6 - g3s_e
    bounds(3) = pi * 0.25 - g4s_e
    bounds(4) = pi * o3 - g5s_e
    bounds(5) = 5 * pi_o12 - g6s_e
    bounds(6) = pi * 0.5 - ecc
    bounds(7) = 7 * pi_o12 - g6s_e
    bounds(8) = 2 * pi * o3 - g5s_e
    bounds(9) = 3 * pi * 0.25 - g4s_e
    bounds(10) = 5 * pi * o6 - g3s_e
    bounds(11) = 11 * pi_o12 - g2s_e
    bounds(12) = pi
    
    over_ecc = 1.d17
    if (ecc .gt. 1.d-17) then
        over_ecc = 1.d0 / ecc
    end if 
    
    do i=1,j,1
        MAsign = 1
        MA = Modulo(M(i), 2 * pi)
        if (MA .gt. pi) then 
            MAsign = -1
            MA = 2 * pi - MA
        end if
    
        if (2 * MA + 1.d0 - ecc .lt. 0.2d0) then 
            EA = EAstart(MA, ecc)
        else
            do k = 11, 1 , -1
                if (MA .gt. bounds(k)) then
                    exit
                end if
            end do
            EA_tab(0) = k * pi_o12
            EA_tab(6) = (k + 1.d0) * pi_o12
            if (k .ge. 6) then
                sig = 1
            else
                sig = -1
            end if
            
            x = 1.d0 / (1.d0 - ((6.d0 - k) * pi_o12 + sig * bounds(abs(6 - k))))
            y = -0.5 * (k * pi_o12 - bounds(k))
            EA_tab(1) = x
            EA_tab(2) = y * x * x * x
            
            x = 1.d0 / (1.d0 - ((5.d0 - k) * pi_o12 + sig * bounds(abs(5 - k))))
            y = -0.5 * ((k + 1.d0) * pi_o12 - bounds(k + 1))
            EA_tab(7) = x
            EA_tab(8) = y * x * x * x
            
            idx = 1.d0 / (bounds(k + 1) - bounds(k))
            
            B0 = idx * (-EA_tab(2) - idx * (EA_tab(1) - idx * pi_o12))
            B1 = idx * (-2 * EA_tab(2) - idx * (EA_tab(1) - EA_tab(7)))
            B2 = idx * (EA_tab(8) - EA_tab(2))
            
            EA_tab(3) = B2 - 4 * B1 + 10 * B0
            EA_tab(4) = (-2 * B2 + 7 * B1 - 15 * B0) * idx
            EA_tab(5) = (B2 - 3 * B1 + 6 * B0) * idx * idx
            
            dx = MA - bounds(k)
            EA = EA_tab(0) &
                 + dx * (EA_tab(1) + dx * (EA_tab(2) + dx * (EA_tab(3) + dx * (EA_tab(4) + dx * EA_tab(5)))))
                 
        end if
                 
        if (EA .lt. pi * 0.25) then
            sE = sine(EA)
            cE = Sqrt(1.d0 - sE * sE)
        else if (EA .gt. 3 * pi * 0.25) then 
            sE = sine(pi - EA)
            cE = - Sqrt(1.d0 - sE * sE)
        else
            cE = sine(pi * 0.5 - EA)
            sE = Sqrt(1.d0 - cE * cE)
        end if
            
        num = (MA - EA) * over_ecc + sE
        denom = over_ecc - cE
        dEA = num * denom / (denom * denom + 0.5 * sE * num)
            
        if ((ecc .lt. 0.78d0) .OR. (MA .gt. 0.4d0)) then 
            sinf(i) = MAsign * (sE * (1.d0 - 0.5 * dEA * dEA) + dEA * cE)
            cosf(i) = cE * (1.d0 - 0.5 * dEA * dEA) - dEA * sE
        else
            dEA = num / (denom + dEA * (0.5 * sE + o6 * cE * dEA))
            sinf(i) = MAsign * (sE * (1.d0 - 0.5 * dEA * dEA) + dEA * cE * (1.d0 - dEA * dEA * o6))
            cosf(i) = cE * (1.d0 - 0.5 * dEA * dEA) - dEA * sE * (1.d0 - dEA * dEA * o6)
        end if
    end do
    
    x = Sqrt((1.d0 + ecc) / (1.d0 - ecc))
    tanfhalf = x * sinf / (1.d0 + cosf)
    tanfhalf2 = tanfhalf * tanfhalf
    d = 1.d0 / (tanfhalf2 + 1.d0)
    cosf = (1.d0 - tanfhalf2) * d
    sinf = 2 * tanfhalf * d
    
end

subroutine grad_kepler_solve(M, ecc, cosf, sinf, f_e, f_M, j) bind(C, name="grad_kepler_solve")

    integer :: j, i
    real*8 :: tol, err, x, ecc
    real (c_double), bind(C), dimension(j) :: M
    real (c_double), bind(C), dimension(j), intent(out) :: cosf, sinf, f_e, f_M
    real*8, dimension(j) :: tanfhalf, tanfhalf2, denom, E, sE, cE
    
    if (ecc .lt. 1.d-10) then
        cE = Cos(M)
        sE = Sin(M)
        
        tanfhalf = sE / (1.d0 + cE)
        tanfhalf2 = tanfhalf * tanfhalf
        denom = 1.d0 / (tanfhalf2 + 1.d0)
        cosf = (1.d0 - tanfhalf2) * denom
        sinf = 2 * tanfhalf * denom
        
        f_M = 1.d0
        f_e = 2.d0 * sinf
    else
        tol = 1.d-10
        
        E = M
        x = Sqrt((1.d0 + ecc) / (1.d0 - ecc))
        
        do i=1,j,1
            err = 10.d0
            do while (abs(err) .gt. tol)
                err = - (E(i) - ecc * Sin(E(i)) - M(i)) / (1.d0 - ecc * Cos(E(i)))
                E(i) = E(i) + err
            end do
        end do    
        
        cE = Cos(E)
        tanfhalf = x * Sin(E) / (1.d0 + cE)
        tanfhalf2 = tanfhalf * tanfhalf
        denom = 1.d0 / (tanfhalf2 + 1.d0)
        cosf = (1.d0 - tanfhalf2) * denom
        sinf = 2 * tanfhalf * denom
        
        x = 1.d0 - ecc**2.d0
        f_M = (1.d0 + ecc * cosf)**2.d0 / x**1.5d0
        f_e = (2.d0 + ecc * cosf) * sinf / x
    end if
end

! pretty much verbatim from DFM's exoplanet code 
subroutine grad_kepler_solve_RPP(M, ecc, cosf, sinf, f_e, f_M, j)

    integer :: j, i, k
    real*8 :: ecc
    real*8, dimension(j) :: M, cosf, sinf, tanfhalf, tanfhalf2, d
    real*8, dimension(j) :: f_e, f_M
    real*8 g2s_e, g3s_e, g4s_e, g5s_e, g6s_e
    real*8, dimension(0:12) :: bounds
    real*8, dimension(0:8) :: EA_tab
    real*8 :: MA, EA, sE, cE, x, y
    real*8 :: B0, B1, B2, dx, idx
    integer :: MAsign, sig
    real*8 :: over_ecc
    real*8 :: num, denom, dEA
    
    g2s_e = 0.2588190451025207623489 * ecc
    g3s_e = 0.5 * ecc
    g4s_e = 0.7071067811865475244008 * ecc
    g5s_e = 0.8660254037844386467637 * ecc
    g6s_e = 0.9659258262890682867497 * ecc
    
    bounds(0) = 0.d0
    bounds(1) = pi_o12 - g2s_e
    bounds(2) = pi * o6 - g3s_e
    bounds(3) = pi * 0.25 - g4s_e
    bounds(4) = pi * o3 - g5s_e
    bounds(5) = 5 * pi_o12 - g6s_e
    bounds(6) = pi * 0.5 - ecc
    bounds(7) = 7 * pi_o12 - g6s_e
    bounds(8) = 2 * pi * o3 - g5s_e
    bounds(9) = 3 * pi * 0.25 - g4s_e
    bounds(10) = 5 * pi * o6 - g3s_e
    bounds(11) = 11 * pi_o12 - g2s_e
    bounds(12) = pi
    
    over_ecc = 1.d17
    if (ecc .gt. 1.d-17) then
        over_ecc = 1.d0 / ecc
    end if 
    
    do i=1,j,1
        MAsign = 1
        MA = Modulo(M(i), 2 * pi)
        if (MA .gt. pi) then 
            MAsign = -1
            MA = 2 * pi - MA
        end if
    
        if (2 * MA + 1.d0 - ecc .lt. 0.2d0) then 
            EA = EAstart(MA, ecc)
        else
            do k = 11, 1 , -1
                if (MA .gt. bounds(k)) then
                    exit
                end if
            end do
            EA_tab(0) = k * pi_o12
            EA_tab(6) = (k + 1.d0) * pi_o12
            if (k .ge. 6) then
                sig = 1
            else
                sig = -1
            end if
            
            x = 1.d0 / (1.d0 - ((6.d0 - k) * pi_o12 + sig * bounds(abs(6 - k))))
            y = -0.5 * (k * pi_o12 - bounds(k))
            EA_tab(1) = x
            EA_tab(2) = y * x * x * x
            
            x = 1.d0 / (1.d0 - ((5.d0 - k) * pi_o12 + sig * bounds(abs(5 - k))))
            y = -0.5 * ((k + 1.d0) * pi_o12 - bounds(k + 1))
            EA_tab(7) = x
            EA_tab(8) = y * x * x * x
            
            idx = 1.d0 / (bounds(k + 1) - bounds(k))
            
            B0 = idx * (-EA_tab(2) - idx * (EA_tab(1) - idx * pi_o12))
            B1 = idx * (-2 * EA_tab(2) - idx * (EA_tab(1) - EA_tab(7)))
            B2 = idx * (EA_tab(8) - EA_tab(2))
            
            EA_tab(3) = B2 - 4 * B1 + 10 * B0
            EA_tab(4) = (-2 * B2 + 7 * B1 - 15 * B0) * idx
            EA_tab(5) = (B2 - 3 * B1 + 6 * B0) * idx * idx
            
            dx = MA - bounds(k)
            EA = EA_tab(0) &
                 + dx * (EA_tab(1) + dx * (EA_tab(2) + dx * (EA_tab(3) + dx * (EA_tab(4) + dx * EA_tab(5)))))
                 
        end if
                 
        if (EA .lt. pi * 0.25) then
            sE = sine(EA)
            cE = Sqrt(1.d0 - sE * sE)
        else if (EA .gt. 3 * pi * 0.25) then 
            sE = sine(pi - EA)
            cE = - Sqrt(1.d0 - sE * sE)
        else
            cE = sine(pi * 0.5 - EA)
            sE = Sqrt(1.d0 - cE * cE)
        end if
            
        num = (MA - EA) * over_ecc + sE
        denom = over_ecc - cE
        dEA = num * denom / (denom * denom + 0.5 * sE * num)
            
        if ((ecc .lt. 0.78d0) .OR. (MA .gt. 0.4d0)) then 
            sinf(i) = MAsign * (sE * (1.d0 - 0.5 * dEA * dEA) + dEA * cE)
            cosf(i) = cE * (1.d0 - 0.5 * dEA * dEA) - dEA * sE
        else
            dEA = num / (denom + dEA * (0.5 * sE + o6 * cE * dEA))
            sinf(i) = MAsign * (sE * (1.d0 - 0.5 * dEA * dEA) + dEA * cE * (1.d0 - dEA * dEA * o6))
            cosf(i) = cE * (1.d0 - 0.5 * dEA * dEA) - dEA * sE * (1.d0 - dEA * dEA * o6)
        end if
    end do
    
    x = Sqrt((1.d0 + ecc) / (1.d0 - ecc))
    tanfhalf = x * sinf / (1.d0 + cosf)
    tanfhalf2 = tanfhalf * tanfhalf
    d = 1.d0 / (tanfhalf2 + 1.d0)
    cosf = (1.d0 - tanfhalf2) * d
    sinf = 2 * tanfhalf * d
    
    x = 1.d0 - ecc**2.d0
    f_M = (1.d0 + ecc * cosf)**2.d0 / x**1.5d0
    f_e = (2.d0 + ecc * cosf) * sinf / x
end

subroutine coords_sat(t, ap, t0p, ep, Pp, wp, ip, am, &
    &t0m, em, Pm, Om, wm, im, mm, j, &
    &xp, yp, zp, xm, ym, zm) bind(C, name="coords_sat")
    
    integer (c_int), bind(C) :: j
    real*8 :: np, nm
    real*8 :: mrp, mrm, comegam, somegam
    real*8 :: cwp, swp, cip, cwm, swm, cim
    real*8, dimension(j) :: x, y, z, xbc, ybc, zbc
    real*8, dimension(j) :: r, cosf, sinf, cosfw, sinfw
    real (c_double), bind(C) :: ap, t0p, ep, Pp, wp, ip, am 
    real (c_double), bind(C) :: t0m, em, Pm, Om, wm, im, mm
    real (c_double), bind(C), dimension(j) :: t
    real (c_double), bind(C), dimension(j), intent(out) :: xp, yp, zp, xm, ym, zm
            
    np = 2 * pi / Pp    
    nm = 2 * pi / Pm

    cwp = Cos(wp)
    swp = Sin(wp)
    cip = Cos(ip)
    
    comegam = Cos(Om)
    somegam = Sin(Om)
    cwm = Cos(wm)
    swm = Sin(wm)
    cim = Cos(im)

    mrp = - 1.d0 / (1.d0 + mm)
    mrm = - mm * mrp
    
    call kepler_solve_RPP(np * (t - t0p), ep, cosf, sinf, j)
    
    r = ap * (1.d0 - ep * ep) / (1.d0 + ep * cosf)
    cosfw = cwp * cosf - swp * sinf
    sinfw = swp * cosf + sinf * cwp
    xbc = -r * cosfw
    ybc = -r * sinfw * cip
    zbc = r * sinfw * Sin(ip)
    
    call kepler_solve_RPP(nm * (t - t0m), em, cosf, sinf, j)
    
    r = am * (1.d0 - em * em) / (1.d0 + em * cosf)
    cosfw = cwm * cosf - swm * sinf
    sinfw = swm * cosf + sinf * cwm
    x = -r * (comegam * cosfw - somegam * sinfw * cim)
    y = -r * (somegam * cosfw + comegam * sinfw * cim)
    z = r * sinfw * Sin(im)
        
    xp = xbc + x * mrm
    yp = ybc + y * mrm
    zp = zbc + z * mrm

    xm = xbc + x * mrp
    ym = ybc + y * mrp
    zm = zbc + z * mrp
    
end

subroutine coords_conf(t, ap, t0p, ep, Pp, wp, ip, am, &
    &t0m, em, Pm, Om, wm, im, j, &
    &xp, yp, zp, xm, ym, zm) bind(C, name="coords_conf")
    
    integer (c_int), bind(C) :: j
    real*8 :: np, nm
    real*8 :: comegam, somegam
    real*8 :: cwp, swp, cip, cwm, swm, cim
    real*8, dimension(j) :: r, cosf, sinf, cosfw, sinfw
    real (c_double), bind(C) :: ap, t0p, ep, Pp, wp, ip 
    real (c_double), bind(C) :: am, t0m, em, Pm, Om, wm, im
    real (c_double), bind(C), dimension(j) :: t
    real (c_double), bind(C), dimension(j), intent(out) :: xp, yp, zp, xm, ym, zm
            
    np = 2 * pi / Pp    
    nm = 2 * pi / Pm

    cwp = Cos(wp)
    swp = Sin(wp)
    cip = Cos(ip)
    
    comegam = Cos(Om)
    somegam = Sin(Om)
    cwm = Cos(wm)
    swm = Sin(wm)
    cim = Cos(im)
    
    call kepler_solve_RPP(np * (t - t0p), ep, cosf, sinf, j)
    
    r = ap * (1.d0 - ep * ep) / (1.d0 + ep * cosf)
    cosfw = cwp * cosf - swp * sinf
    sinfw = swp * cosf + sinf * cwp
    xp = -r * cosfw
    yp = -r * sinfw * cip
    zp = r * sinfw * Sin(ip)
    
    call kepler_solve_RPP(nm * (t - t0m), em, cosf, sinf, j)
    
    r = am * (1.d0 - em * em) / (1.d0 + em * cosf)
    cosfw = cwm * cosf - swm * sinf
    sinfw = swm * cosf + sinf * cwm
    xm = -r * (comegam * cosfw - somegam * sinfw * cim)
    ym = -r * (somegam * cosfw + comegam * sinfw * cim)
    zm = r * sinfw * Sin(im)
    
end

subroutine grad_coords_sat(t, ap, t0p, ep, Pp, wp, ip, am, &
    &t0m, em, Pm, Om, wm, im, mm, j, &
    &xp, yp, xm, ym, dxp, dyp, dxm, dym) bind(C, name="grad_coords_sat")

    integer (c_int), bind(C) :: j
    real*8 :: np, nm
    real*8 :: mrp, mrm, comegam, somegam
    real*8 :: cwp, swp, cip, cwm, swm, cim, sip, sim
    real*8, dimension(j) :: x, y, xbc, ybc
    real*8, dimension(j) :: r, cosf, sinf, cosfw, sinfw, denom
    real (c_double), bind(C) :: ap, t0p, ep, Pp, wp, ip, am 
    real (c_double), bind(C) :: t0m, em, Pm, Om, wm, im, mm
    real (c_double), bind(C), dimension(j) :: t
    real (c_double), bind(C), dimension(j), intent(out) :: xp, yp, xm, ym
    
    real (c_double), bind(C), dimension(j, 14), intent(out) :: dxp, dyp, dxm, dym
    real*8, dimension(j) :: xbc_a, ybc_a, x_a, y_a
    
    real*8 :: np_Pp, nm_Pm
    real*8 :: np_ms, np_mp, np_mm, nm_mp, nm_mm
    real*8 :: mrp_mm, mrm_mm, mp
    real*8, dimension(j) :: r_t0, r_e, r_cosf
    real*8, dimension(j) :: f_M, f_e
    real*8, dimension(j) :: ccmss, cspsc, scpcs, ssmcc
    real*8, dimension(j) :: r_Pp, r_Pm
        
    np = 2 * pi / Pp
    np_Pp = -np / Pp
    
    nm = 2 * pi / Pm
    nm_Pm = -nm / Pm
    
    cwp = Cos(wp)
    swp = Sin(wp)
    cip = Cos(ip)
    sip = Sin(ip)
    
    comegam = Cos(Om)
    somegam = Sin(Om)
    cwm = Cos(wm)
    swm = Sin(wm)
    cim = Cos(im)
    sim = Sin(im)

    mrp = - 1.d0 / (1.d0 + mm)
    mrm = - mm * mrp
    
    mrp_mm = - mrp / (1.d0 + mm)
    mrm_mm = mrp_mm
    
    mp = 1.d0 / mm
    
    call grad_kepler_solve_RPP(np * (t - t0p), ep, cosf, sinf, f_e, f_M, j)
    
    denom = 1.d0 / (1.d0 + ep * cosf)
    r = ap * (1.d0 - ep * ep) * denom
    r_cosf = - r * ep * denom
    r_t0 = r_cosf * sinf * f_M * np
    r_e = -r_cosf * sinf * f_e - ap * (cosf + 2 * ep + cosf * ep * ep) * denom * denom
    r_Pp = -r_cosf * sinf * f_M * (t - t0p) * np_Pp
     
    cosfw = cwp * cosf - swp * sinf
    sinfw = swp * cosf + sinf * cwp
    
    ccmss = cosfw
    cspsc = sinfw
    scpcs = sinfw * cip
    ssmcc = - cosfw * cip
    xbc = -r * ccmss
    xbc_a = - r * ccmss / ap
    ybc = -r * scpcs
    ybc_a = - r * scpcs / ap
    
    dxp(:, 1) = xbc_a
    dxm(:, 1) = xbc_a
    dxp(:, 2) = - r_t0 * ccmss - r * f_M * np * cspsc
    dxm(:, 2) = dxp(:, 2)
    dxp(:, 3) = - r_e * ccmss + r * f_e * cspsc
    dxm(:, 3) = dxp(:, 3)
    dxp(:, 4) = - r_Pp * ccmss + r * f_M * (t - t0p) * np_Pp * cspsc
    dxm(:, 4) = dxp(:, 4)
    dxp(:, 5) = r * cspsc
    dxm(:, 5) = dxp(:, 5)
    dxp(:, 6) = 0.d0
    dxm(:, 6) = 0.d0
        
    ! ms
    dyp(:, 1) = ybc_a
    dym(:, 1) = ybc_a
    ! t0p
    dyp(:, 2) = - r_t0 * scpcs - r * f_M * np * ssmcc
    dym(:, 2) = dyp(:, 2)
    ! ep
    dyp(:, 3) = - r_e * scpcs + r * f_e * ssmcc
    dym(:, 3) = dyp(:, 3)
    ! Pp
    dyp(:, 4) = - r_Pp * scpcs + r * f_M * (t - t0p) * np_Pp * ssmcc
    dym(:, 4) = dyp(:, 4)
    ! wp
    dyp(:, 5) = r * ssmcc
    dym(:, 5) = dyp(:, 5)
    ! ip
    dyp(:, 6) = r * sinfw * sip
    dym(:, 6) = dyp(:, 6)
    
    call grad_kepler_solve_RPP(nm * (t - t0m), em, cosf, sinf, f_e, f_M, j)
    
    denom = 1.d0 / (1.d0 + em * cosf)
    r = am * (1.d0 - em * em) * denom
    r_cosf = - em * r * denom
    r_t0 = r_cosf * sinf * f_M * nm
    r_e = -r_cosf * sinf * f_e - am * (cosf + 2 * em + cosf * em * em) * denom * denom
    r_Pm = -r_cosf * sinf * f_M * (t - t0m) * nm_Pm
     
    cosfw = cwm * cosf - swm * sinf
    sinfw = swm * cosf + sinf * cwm
    
    ccmss = comegam * cosfw - somegam * sinfw * cim
    cspsc = comegam * sinfw + somegam * cosfw * cim
    scpcs = somegam * cosfw + comegam * sinfw * cim
    ssmcc = somegam * sinfw - comegam * cosfw * cim
    x = -r * ccmss
    x_a = -r * ccmss / am
    y = -r * scpcs
    y_a = -r * scpcs / am
        
    ! ms, t0p, ep, Pp, Op, wp, ip, mp, t0m, em, Pm, wm, Om, im, mm
    xp = xbc + x * mrm
    
    dxp(:, 7) = x_a * mrm
    dxp(:, 8) = (- r_t0 * ccmss - r * f_M * nm * cspsc) * mrm
    dxp(:, 9) = (- r_e * ccmss + r * f_e * cspsc) * mrm
    dxp(:, 10) = (- r_Pm * ccmss + r * f_M * (t - t0m) * nm_Pm * cspsc) * mrm
    dxp(:, 11) = r * cspsc * mrm
    dxp(:, 12) = r * scpcs * mrm
    dxp(:, 13) = -r * somegam * sinfw * sim * mrm
    dxp(:, 14) = x * mrm_mm
    
    yp = ybc + y * mrm

    dyp(:, 7) = y_a * mrm
    dyp(:, 8) = (- r_t0 * scpcs - r * f_M * nm * ssmcc) * mrm
    dyp(:, 9) = (- r_e * scpcs + r * f_e * ssmcc) * mrm
    dyp(:, 10) = (- r_Pm * scpcs + r * f_M * (t - t0m) * nm_Pm * ssmcc) * mrm
    dyp(:, 11) = r * ssmcc * mrm
    dyp(:, 12) = - r * ccmss * mrm
    dyp(:, 13) = r * comegam * sinfw * sim * mrm
    dyp(:, 14) = y * mrm_mm

    xm = xbc + x * mrp

    dxm(:, 7) = x_a * mrm
    dxm(:, 8) = -dxp(:, 8) * mp
    dxm(:, 9) = -dxp(:, 9) * mp
    dxm(:, 10) = -dxp(:, 10) * mp
    dxm(:, 11) = -dxp(:, 11) * mp
    dxm(:, 12) = -dxp(:, 12) * mp
    dxm(:, 13) = -dxp(:, 13) * mp
    dxm(:, 14) = x * mrp_mm
    
    ym = ybc + y * mrp

    dym(:, 7) = y_a * mrp
    dym(:, 8) = -dyp(:, 8) * mp
    dym(:, 9) = -dyp(:, 9) * mp
    dym(:, 10) = -dyp(:, 10) * mp
    dym(:, 11) = -dyp(:, 11) * mp
    dym(:, 12) = -dyp(:, 12) * mp
    dym(:, 13) = -dyp(:, 13) * mp
    dym(:, 14) = y * mrp_mm
    
end

subroutine grad_coords_conf(t, ap, t0p, ep, Pp, wp, ip, am, &
    &t0m, em, Pm, Om, wm, im, j, &
    &xp, yp, xm, ym, dxp, dyp, dxm, dym) bind(C, name="grad_coords_conf")

    integer (c_int), bind(C) :: j
    real*8 :: np, nm
    real*8 :: comegam, somegam
    real*8 :: cwp, swp, cip, cwm, swm, cim, sip, sim
    real*8, dimension(j) :: r, cosf, sinf, cosfw, sinfw, denom
    real (c_double), bind(C) :: ap, t0p, ep, Pp, wp, ip 
    real (c_double), bind(C) :: am, t0m, em, Pm, Om, wm, im
    real (c_double), bind(C), dimension(j) :: t
    real (c_double), bind(C), dimension(j), intent(out) :: xp, yp, xm, ym
    real (c_double), bind(C), dimension(j, 13), intent(out) :: dxp, dyp, dxm, dym
    
    real*8 :: np_Pp, nm_Pm
    real*8 :: np_ms, np_mp, np_mm, nm_mp, nm_mm
    real*8, dimension(j) :: r_t0, r_e, r_cosf
    real*8, dimension(j) :: f_M, f_e
    real*8, dimension(j) :: ccmss, cspsc, scpcs, ssmcc
    real*8, dimension(j) :: r_Pp, r_Pm
        
    np = 2 * pi / Pp
    np_Pp = -np / Pp
    
    nm = 2 * pi / Pm
    nm_Pm = -nm / Pm
    
    cwp = Cos(wp)
    swp = Sin(wp)
    cip = Cos(ip)
    sip = Sin(ip)
    
    comegam = Cos(Om)
    somegam = Sin(Om)
    cwm = Cos(wm)
    swm = Sin(wm)
    cim = Cos(im)
    sim = Sin(im)
    
    call grad_kepler_solve_RPP(np * (t - t0p), ep, cosf, sinf, f_e, f_M, j)
    
    denom = 1.d0 / (1.d0 + ep * cosf)
    r = ap * (1.d0 - ep * ep) * denom
    r_cosf = - r * ep * denom
    r_t0 = r_cosf * sinf * f_M * np
    r_e = -r_cosf * sinf * f_e - ap * (cosf + 2 * ep + cosf * ep * ep) * denom * denom
    r_Pp = -r_cosf * sinf * f_M * (t - t0p) * np_Pp
     
    cosfw = cwp * cosf - swp * sinf
    sinfw = swp * cosf + sinf * cwp
    
    ccmss = cosfw
    cspsc = sinfw
    scpcs = sinfw * cip
    ssmcc = - cosfw * cip
    xp = -r * ccmss
    yp = -r * scpcs
    
    dxp(:, 1) = - r * ccmss / ap
    dxm(:, 1) = 0.d0
    dxp(:, 2) = - r_t0 * ccmss - r * f_M * np * cspsc
    dxm(:, 2) = 0.d0
    dxp(:, 3) = - r_e * ccmss + r * f_e * cspsc
    dxm(:, 3) = 0.d0
    dxp(:, 4) = - r_Pp * ccmss + r * f_M * (t - t0p) * np_Pp * cspsc
    dxm(:, 4) = 0.d0
    dxp(:, 5) = r * cspsc
    dxm(:, 5) = 0.d0
    dxp(:, 6) = 0.d0
    dxm(:, 6) = 0.d0
        
    ! ms
    dyp(:, 1) = - r * scpcs / ap
    dym(:, 1) = 0.d0
    ! t0p
    dyp(:, 2) = - r_t0 * scpcs - r * f_M * np * ssmcc
    dym(:, 2) = 0.d0
    ! ep
    dyp(:, 3) = - r_e * scpcs + r * f_e * ssmcc
    dym(:, 3) = 0.d0
    ! Pp
    dyp(:, 4) = - r_Pp * scpcs + r * f_M * (t - t0p) * np_Pp * ssmcc
    dym(:, 4) = 0.d0
    ! wp
    dyp(:, 5) = r * ssmcc
    dym(:, 5) = 0.d0
    ! ip
    dyp(:, 6) = r * sinfw * sip
    dym(:, 6) = 0.d0
    
    call grad_kepler_solve_RPP(nm * (t - t0m), em, cosf, sinf, f_e, f_M, j)
    
    denom = 1.d0 / (1.d0 + em * cosf)
    r = am * (1.d0 - em * em) * denom
    r_cosf = - em * r * denom
    r_t0 = r_cosf * sinf * f_M * nm
    r_e = -r_cosf * sinf * f_e - am * (cosf + 2 * em + cosf * em * em) * denom * denom
    r_Pm = -r_cosf * sinf * f_M * (t - t0m) * nm_Pm
     
    cosfw = cwm * cosf - swm * sinf
    sinfw = swm * cosf + sinf * cwm
    
    ccmss = comegam * cosfw - somegam * sinfw * cim
    cspsc = comegam * sinfw + somegam * cosfw * cim
    scpcs = somegam * cosfw + comegam * sinfw * cim
    ssmcc = somegam * sinfw - comegam * cosfw * cim
    xm = -r * ccmss
    ym = -r * scpcs
        
    ! ms, t0p, ep, Pp, Op, wp, ip, mp, t0m, em, Pm, wm, Om, im, mm
    
    dxp(:, 7) = 0.d0
    dxp(:, 8) = 0.d0
    dxp(:, 9) = 0.d0
    dxp(:, 10) = 0.d0
    dxp(:, 11) = 0.d0
    dxp(:, 12) = 0.d0
    dxp(:, 13) = 0.d0
    
    dyp(:, 7) = 0.d0
    dyp(:, 8) = 0.d0
    dyp(:, 9) = 0.d0
    dyp(:, 10) = 0.d0
    dyp(:, 11) = 0.d0
    dyp(:, 12) = 0.d0
    dyp(:, 13) = 0.d0

    dxm(:, 7) = -r * ccmss / am
    dxm(:, 8) = - r_t0 * ccmss - r * f_M * nm * cspsc
    dxm(:, 9) = - r_e * ccmss + r * f_e * cspsc
    dxm(:, 10) = - r_Pm * ccmss + r * f_M * (t - t0m) * nm_Pm * cspsc
    dxm(:, 11) = r * cspsc
    dxm(:, 12) = r * scpcs
    dxm(:, 13) = -r * somegam * sinfw * sim
    
    dym(:, 7) = - r * scpcs / am
    dym(:, 8) = - r_t0 * scpcs - r * f_M * nm * ssmcc
    dym(:, 9) = - r_e * scpcs + r * f_e * ssmcc
    dym(:, 10) = - r_Pm * scpcs + r * f_M * (t - t0m) * nm_Pm * ssmcc
    dym(:, 11) = r * ssmcc
    dym(:, 12) = -r * ccmss
    dym(:, 13) = r * comegam * sinfw * sim
    
end

subroutine grad_impacts_sat(t, ap, t0p, ep, Pp, wp, ip, am, &
    &t0m, em, Pm, Om, wm, im, mm, j, &
    &bp, bpm, theta, dbp, dbpm, dtheta) bind(C, name="grad_impacts_sat")

    integer :: i
    real*8 :: a, b, c, tmp, mu
    real*8, dimension(j) :: bm, bm2, bp2, bpm2, sth
    real*8, dimension(j) :: xp, yp, xm, ym
    real*8, dimension(j) :: bm_xm, bm_ym, bp_xp, bp_yp, bpm_xm, bpm_ym, bpm_xp, bpm_yp
    real*8, dimension(j) :: theta_bp, theta_bpm, theta_bm, denom
    real*8, dimension(j, 14) :: dxp, dyp, dxm, dym, dbm
    integer (c_int), bind(C) :: j
    real (c_double), bind(C) :: ap, t0p, ep, Pp, wp, ip, am 
    real (c_double), bind(C) :: t0m, em, Pm, Om, wm, im, mm
    real (c_double), bind(C), dimension(j) :: t
    real (c_double), bind(C), intent(out), dimension(j) :: bp, bpm, theta
    real (c_double), bind(C), intent(out), dimension(j, 14) :: dbp, dbpm, dtheta
    
    call grad_coords_sat(t, ap, t0p, ep, Pp, wp, ip, am, t0m, em, &
                Pm, Om, wm, im, mm, j, xp, yp, xm, ym, &
                dxp, dyp, dxm, dym)
        
    bm2 = xm**2.d0 + ym**2.d0
    bm = Sqrt(bm2)
    bm_xm = xm / bm
    bm_ym = ym / bm
    
    bp2 = xp**2.d0 + yp**2.d0
    bp = Sqrt(bp2)
    bp_xp = xp / bp
    bp_yp = yp / bp
    
    bpm2 = (xm - xp)**2.d0 + (ym - yp)**2.d0
    bpm = Sqrt(bpm2)
    bpm_xm = (xm - xp) / bpm
    bpm_ym = (ym - yp) / bpm
    bpm_xp = - bpm_xm
    bpm_yp = - bpm_ym
    
    do i=1,j,1
    
        a = bp(i) 
        b = bpm(i)
        c = bm(i)
        
        if (a .GT. b) then
            tmp = b
            b = a
            a = tmp
        end if
        if (b .GT. c) then
            mu = c - (a - b)
        else
            mu = b - (a - c)
        end if
            
        theta(i) = 2 * Atan(Sqrt(((a - b) + c) * mu / ((a + (b + c)) * ((a - c) + b))))
    end do
    
    sth = Sin(theta)
    denom = 1.d0 / (bp2 * bpm2 * sth)
    theta_bm = bm * bp * bpm * denom
    theta_bp = ((bpm - bm) * (bpm + bm) - bp2) * 0.5 * bpm * denom
    theta_bpm = ((bp - bm) * (bp + bm) - bpm2) * 0.5 * bp * denom
    
    do i=1,14,1
        dbm(:, i) = bm_xm * dxm(:, i) + bm_ym * dym(:, i)
        dbp(:, i) = bp_xp * dxp(:, i) + bp_yp * dyp(:, i)
        dbpm(:, i) = bpm_xm * dxm(:, i) + bpm_ym * dym(:, i) &
                   + bpm_xp * dxp(:, i) + bpm_yp * dyp(:, i)
        dtheta(:, i) = theta_bm * dbm(:, i) &
                     + theta_bp * dbp(:, i) &
                     + theta_bpm * dbpm(:, i)
    end do

    bp = bp * au_rsun
    bpm = bpm * au_rsun
    dbp = dbp * au_rsun
    dbpm = dbpm * au_rsun
            
end

subroutine grad_impacts_conf(t, ap, t0p, ep, Pp, wp, ip, am, &
    &t0m, em, Pm, Om, wm, im, j, &
    &bp, bpm, theta, dbp, dbpm, dtheta) bind(C, name="grad_impacts_conf")

    integer :: i
    real*8 :: a, b, c, tmp, mu
    real*8, dimension(j) :: bm, bm2, bp2, bpm2, sth
    real*8, dimension(j) :: xp, yp, xm, ym
    real*8, dimension(j) :: bm_xm, bm_ym, bp_xp, bp_yp, bpm_xm, bpm_ym, bpm_xp, bpm_yp
    real*8, dimension(j) :: theta_bp, theta_bpm, theta_bm, denom
    real*8, dimension(j, 13) :: dxp, dyp, dxm, dym, dbm
    integer (c_int), bind(C) :: j
    real (c_double), bind(C) :: ap, t0p, ep, Pp, wp, ip, am 
    real (c_double), bind(C) :: t0m, em, Pm, Om, wm, im
    real (c_double), bind(C), dimension(j) :: t
    real (c_double), bind(C), intent(out), dimension(j) :: bp, bpm, theta
    real (c_double), bind(C), intent(out), dimension(j, 13) :: dbp, dbpm, dtheta
    
    call grad_coords_conf(t, ap, t0p, ep, Pp, wp, ip, am, t0m, em, &
                Pm, Om, wm, im, j, xp, yp, xm, ym, &
                dxp, dyp, dxm, dym)
        
    bm2 = xm**2.d0 + ym**2.d0
    bm = Sqrt(bm2)
    bm_xm = xm / bm
    bm_ym = ym / bm
    
    bp2 = xp**2.d0 + yp**2.d0
    bp = Sqrt(bp2)
    bp_xp = xp / bp
    bp_yp = yp / bp
    
    bpm2 = (xm - xp)**2.d0 + (ym - yp)**2.d0
    bpm = Sqrt(bpm2)
    bpm_xm = (xm - xp) / bpm
    bpm_ym = (ym - yp) / bpm
    bpm_xp = - bpm_xm
    bpm_yp = - bpm_ym
    
    do i=1,j,1
    
        a = bp(i) 
        b = bpm(i)
        c = bm(i)
        
        if (a .GT. b) then
            tmp = b
            b = a
            a = tmp
        end if
        if (b .GT. c) then
            mu = c - (a - b)
        else
            mu = b - (a - c)
        end if
            
        theta(i) = 2 * Atan(Sqrt(((a - b) + c) * mu / ((a + (b + c)) * ((a - c) + b))))
    end do
    
    sth = Sin(theta)
    denom = 1.d0 / (bp2 * bpm2 * sth)
    theta_bm = bm * bp * bpm * denom
    theta_bp = ((bpm - bm) * (bpm + bm) - bp2) * 0.5 * bpm * denom
    theta_bpm = ((bp - bm) * (bp + bm) - bpm2) * 0.5 * bp * denom
    
    do i=1,13,1
        dbm(:, i) = bm_xm * dxm(:, i) + bm_ym * dym(:, i)
        dbp(:, i) = bp_xp * dxp(:, i) + bp_yp * dyp(:, i)
        dbpm(:, i) = bpm_xm * dxm(:, i) + bpm_ym * dym(:, i) &
                   + bpm_xp * dxp(:, i) + bpm_yp * dyp(:, i)
        dtheta(:, i) = theta_bm * dbm(:, i) &
                     + theta_bp * dbp(:, i) &
                     + theta_bpm * dbpm(:, i)
    end do

    bp = bp * au_rsun
    bpm = bpm * au_rsun
    dbp = dbp * au_rsun
    dbpm = dbpm * au_rsun
            
end

subroutine impacts_sat(t, ap, t0p, ep, Pp, wp, ip, am, &
    &t0m, em, Pm, Om, wm, im, mm, j, bp, bpm, theta) bind(C, name="impacts_sat")

    integer :: i
    real*8 :: a, b, c, tmp, mu
    real*8, dimension(j) :: bm, bm2, bp2, bpm2
    real*8, dimension(j) :: xp, yp, xm, ym, zp, zm
    integer (c_int), bind(C) :: j
    real (c_double), bind(C) :: ap, t0p, ep, Pp, wp, ip, am 
    real (c_double), bind(C) :: t0m, em, Pm, Om, wm, im, mm
    real (c_double), bind(C), dimension(j) :: t
    real (c_double), bind(C), intent(out), dimension(j) :: bp, bpm, theta
    
    call coords_sat(t, ap, t0p, ep, Pp, wp, ip, am, t0m, em, &
                Pm, Om, wm, im, mm, j, xp, yp, zp, xm, ym, zm)
    
    bm2 = xm**2.d0 + ym**2.d0
    bm = Sqrt(bm2)
    
    bp2 = xp**2.d0 + yp**2.d0
    bp = Sqrt(bp2)
    
    bpm2 = (xm - xp)**2.d0 + (ym - yp)**2.d0
    bpm = Sqrt(bpm2)
    
    do i=1,j,1
    
        a = bp(i) 
        b = bpm(i)
        c = bm(i)
        
        if (a .gt. b) then
            tmp = b
            b = a
            a = tmp
        end if
        if (b .gt. c) then
            mu = c - (a - b)
        else
            mu = b - (a - c)
        end if
        
        if ((bpm(i) .eq. 0.d0) .or. ((a - b + c) .lt. 1.d-15)) then
            theta(i) = 0.d0
        else if ((a - c + b) .lt. 1.d-15) then 
            theta(i) = pi
        else
            theta(i) = 2 * Atan(Sqrt(((a - b) + c) * mu / ((a + (b + c)) * ((a - c) + b))))
        end if
    end do

    bp = bp * au_rsun
    bpm = bpm * au_rsun
            
end

subroutine impacts_conf(t, ap, t0p, ep, Pp, wp, ip, am, &
    &t0m, em, Pm, Om, wm, im, j, bp, bpm, theta) bind(C, name="impacts_conf")

    integer :: i
    real*8 :: a, b, c, tmp, mu
    real*8, dimension(j) :: bm, bm2, bp2, bpm2
    real*8, dimension(j) :: xp, yp, xm, ym, zp, zm
    integer (c_int), bind(C) :: j
    real (c_double), bind(C) :: ap, t0p, ep, Pp, wp, ip, am 
    real (c_double), bind(C) :: t0m, em, Pm, Om, wm, im
    real (c_double), bind(C), dimension(j) :: t
    real (c_double), bind(C), intent(out), dimension(j) :: bp, bpm, theta
    
    call coords_conf(t, ap, t0p, ep, Pp, wp, ip, am, t0m, em, &
                Pm, Om, wm, im, j, xp, yp, zp, xm, ym, zm)
    
    bm2 = xm**2.d0 + ym**2.d0
    bm = Sqrt(bm2)
    
    bp2 = xp**2.d0 + yp**2.d0
    bp = Sqrt(bp2)
    
    bpm2 = (xm - xp)**2.d0 + (ym - yp)**2.d0
    bpm = Sqrt(bpm2)
    
    do i=1,j,1
    
        a = bp(i) 
        b = bpm(i)
        c = bm(i)
        
        if (a .gt. b) then
            tmp = b
            b = a
            a = tmp
        end if
        if (b .gt. c) then
            mu = c - (a - b)
        else
            mu = b - (a - c)
        end if
        
        if ((bpm(i) .eq. 0.d0) .or. ((a - b + c) .lt. 1.d-15)) then
            theta(i) = 0.d0
        else if ((a - c + b) .lt. 1.d-15) then 
            theta(i) = pi
        else
            theta(i) = 2 * Atan(Sqrt(((a - b) + c) * mu / ((a + (b + c)) * ((a - c) + b))))
        end if
    end do

    bp = bp * au_rsun
    bpm = bpm * au_rsun
            
end

end

module ellip
implicit none

!real*8 :: el1, el2, el3
real*8, parameter :: pi = 4.d0 * Atan(1.d0)
real*8, parameter :: ln2 = log(2.d0)
real*8, parameter :: pihalf = 2.d0 * Atan(1.d0)

contains

real*8 function el1(x, kc)

    integer :: j
    real*8 :: x, kc, e
    !real, intent(out) :: e
    
    real*8 :: g, m, y
    real*8 :: D = 15
    real*8 :: ca, cb
    !real*8 :: pi = 4.d0 * Atan(1.d0)
    integer :: l, i
    
    ca = 10**(-D/2.d0)
    cb = 10**(-D+2.d0)
    
    y = abs(1.d0/x)
    kc = abs(kc)
    m = 1.d0
    
    if (kc == 0.d0) then
        e = log(x + 1.d0 / cos(atan(x)))
        goto 2
    end if
    
    l = 0
        
1   e = m * kc
    g = m
    m = kc + m
    y = - (e/y) + y
    if (y == 0) then
        y = sqrt(e) * cb
    end if 
    if (abs(g - kc) .gt. ca * g) then
        kc = 2 * sqrt(e)
        l = 2 * l
        if (y .lt. 0) then
            l = l + 1
        end if 
        goto 1
    end if
    if (y .lt. 0) then 
        l = l + 1
    end if 
    e = (atan(m/y) + pi * l) / m
    if (x .lt. 0) then
        e = -e
    end if
    
2 el1 = e
return
end

real*8 function el2(x, kc, a, b)

    real*8 :: x, kc, a, b, e
    !real, intent(out) :: e
    
    real*8 :: c, dd, f, g, ik, m, p, y, z
    real*8 :: D = 15
    real*8 :: ca, cb
    !real*8 :: pi = 4.d0 * Atan(1.d0)
    integer :: l, i
    
    ca = 10**(-D/2.d0)
    cb = 10**(-D+2.d0)
    
    c = x**2
    dd = c + 1.d0
    p = sqrt((1.d0 + kc**2 * c)/dd)
    dd = x / dd
    c = dd / (2.d0 * p)
    z = a - b
    ik = a
    a = (b + a) * 0.5
    y = abs(1.d0/x)
    f = 0.d0
    kc = abs(kc)
    m = 1.d0
        
    if (kc == 0.d0) then
        e = sin(atan(x))
        goto 2
    end if

    l = 0
1   b = ik * kc + b
    e = m * kc
    g = e / p
    dd = f * g + dd
    f = c
    ik = a
    p = g + p
    c = (dd / p + c) / 2.d0
    g = m
    m = kc + m
    a = (b / m + a) * 0.5
    y = - (e/y) + y
    if (y == 0) then
        y = sqrt(e) * cb
    end if 
    if (abs(g - kc) .gt. ca * g) then
        kc = 2 * sqrt(e)
        l = 2 * l
        if (y .lt. 0) then
            l = l + 1
        end if 
        goto 1
    end if
    if (y .lt. 0) then 
        l = l + 1
    end if 
    e = (atan(m/y) + pi * l) * (a / m)
    if (x .lt. 0) then
        e = -e
    else
        e = e + c * z
    end if
    
2 el2 = e
return
end

real*8 function el3(x, kc, p)

    real*8 :: x, kc, p, e
    !real, intent(out) :: e
    
    real*8 :: am, ap, c, d, de, f, fa, g
    real*8 :: h, hh, p1, pm, pz, q, r, s 
    real*8 :: t, u, v, w, y, ye, z, zd
    real*8 :: ca, cb
    real*8 :: cD = 15
    !real*8 :: pi = 4.d0 * Atan(1.d0)
    !real*8 :: ln2 = 0.6931471805599453
    integer :: l, m, n, ND, i, k
    logical :: bo, bk
    real*8 :: ra(10), rb(10), rr(10)
    
    !ca = 1E-6
    !cb = 1E-14
    ca = 10**(-cD/2.d0)
    cb = 10**(-cD+2.d0)
    ND = 10
    
    hh = x * x
    f = p * hh
        
    if (kc == 0.d0) then
        s = ca / (1.d0 + abs(x))
    else
        s = kc
    end if
    t = s * s
    pm = t * 0.5
    e = hh * t
    z = abs(f)
    r = abs(p)
    h = 1.d0 + hh
    if ((e .lt. 1.d0) .AND. (z .lt. 0.1) .AND. (t .lt. 1.d0) .AND. (r .lt. 1.d0)) then
        goto 1
    end if 
    w = 1.d0 + f
    if (w == 0.d0) then
        goto 4
    end if
    if (p == 0.d0) then
        p1 = cb / hh
    else
        p1 = p
    end if
    s = abs(s)
    y = abs(x)
    g = p1 - 1.d0
    if (g == 0.d0) then
        g = cb
    end if
    f = p1 - t
    if (f == 0.d0) then
        f = cb * t
    end if 
    am = 1.d0 - t
    ap = 1.d0 + e
    r = p1 * h
    fa = g / (f * p1)
    bo = fa .gt. 0.d0
    fa = abs(fa)
    pz = abs(g * f)
    de = sqrt(pz)
    q = sqrt(abs(p1))
    if (pm .gt. 0.5) then 
        pm = 0.5
    end if
    pm = p1 - pm
    if (pm .ge. 0.d0) then
        u = sqrt(r * ap)
        v = y * de
        if (g .lt. 0.d0) then
            v = -v
        end if
        d = 1.d0 / q
        c = 1.d0
    else
        u = sqrt(h * ap * pz)
        ye = y * q
        v = am * ye
        q = -de / g
        d = -am / de
        c = 0.d0
        pz = ap - r
    end if
    if (bo) then
        r = v / u
        z = 1.d0
        k = 1
        if (pm .lt. 0.d0) then
            h = y * sqrt(h / (ap * fa))
            h = 1.d0 / h - h
            z = h - r - r
            r = 2.d0 + r * h
            if (r == 0.d0) then
                r = cb
            end if
            if (z == 0.d0) then 
                z = h * cb
            end if
            r = r / z
            z = r
            w = pz
        end if
        u = u / w
        v = v / w
    else
        t = u + abs(v)
        bk = .TRUE.
        if (p1 .lt. 0.d0) then
            de = v / pz
            ye = u * ye
            ye = ye + ye
            u = t / pz
            v = (-f - g * e) / t
            t = pz * abs(w)
            z = (hh * r * f - g * ap + ye) / t
            ye = ye / t
        else
            de = v / w 
            ye = 0.d0
            u = (e + p1) / t
            v = t / w
            z = 1.d0
        end if
        if (s .gt. 1.d0) then
            h = u
            u = v
            v = h
        end if
    end if
    y = 1.d0 / y
    e = s
    n = 1
    t = 1.d0
    m = 0
    l = 0
3   y = y - e / y
    if (y == 0.d0) then
        y = sqrt(e) * cb
    end if
    f = c
    c = d / q + c
    g = e / q
    d = f * g + d
    d = d + d
    q = g + q
    g = t
    t = s + t
    n = n + n
    m = m + m
    if (bo) then 
        if (z .lt. 0.d0) then 
            m = k + m
        end if 
        k = int(sign(1.d0, r))
        h = e / (u * u + v * v)
        u = u * (1.d0 + h)
        v = v * (1.d0 - h)
    else
        r = u / v 
        h = z * r
        z = h * z
        hh = e / v
        if (bk) then
            de = de / u
            ye = ye * (h + 1.d0 / h) + de * (1.d0 + r)
            de = de * (u - hh)
            bk = abs(ye) .lt. 1.d0
        else
            k = exponent(z)
            z = fraction(z)
            m = m + k
        end if
    end if
    if (abs(g - s) .gt. ca * g) then 
        if (bo) then
            g = (1.d0 / r - r) * 0.5
            hh = u + v * g
            h = g * u - v
            if (hh == 0.d0) then
                hh = u * cb
            end if
            if (h == 0.d0) then
                h = v * cb
            end if
            z = r * h
            r = hh / h
        else
            u = u + e / u
            v = v + hh
        end if
        s = sqrt(e)
        s = s + s
        e = s * t
        l = l + l
        if (y .lt. 0.d0) then 
            l = 1 + l
        end if 
        goto 3
    end if
    if (y .lt. 0.d0) then
        l = 1 + l
    end if
    e = atan(t / y) + pi * l
    e = e * (c * t + d) / (t * (t + q))
    if (bo) then 
        h = v / (t + u)
        z = 1.d0 - r * h
        h = r + h
        if (z == 0.d0) then
            z = cb
        end if
        if (z .lt. 0.d0) then
            m = m + int(sign(1.d0, h))
        end if
        s = atan(h / z) + m * pi
    else
        if (bk) then
            s = asinh(ye)
        else
            s = log(z) + m * ln2
        end if
        s = s * 0.5
    end if
    e = (e + sqrt(fa) * s) / n
    if (x .le. 0.d0) then
        e = -e
    end if
    goto 4

1   do k=2,ND,1
        rb(k) = 0.5 / k
        ra(k) = 1.d0 - rb(k)
    end do
    zd = 0.5 / (ND + 1)
    s = p + pm
    do k=2,ND,1
        rr(k) = s
        pm = pm * t * ra(k)
        s = s * p + pm
    end do
    u = s * zd
    s = u
    bo = .FALSE.
    do k=ND,2,-1
        u = u + (rr(k) - u) * rb(k)
        bo = .NOT. bo
        if (bo) then
            v = -u
        else
            v = u
        end if
        s = s * hh + v
    end do
    if (bo) then
        s = -s
    end if
    u = (u + 1.d0) * 0.5
    e = (u - s * h) * sqrt(h) * x + u * asinh(x)
    
4 el3 = e
return
end

real*8 function cel(kc, p, a, b)

    real*8 :: kc, p, a, b
    real*8 :: CA, e, f, g, m, q
    
    CA = 1.d-7
    
    kc = abs(kc)
    e = kc
    m = 1.d0

    if (p .gt. 0.d0) then
        p = sqrt(p)
        b = b / p
    else
        f = kc * kc
        q = 1.d0 - f
        g = 1.d0 - p
        f = f - p
        q = (b - a * p) * q
        p = sqrt(f / g)
        a = (a - b) / g
        b = -q / (g * g * p) + a * p
    end if 

1   f = a
    a = b / p + a
    g = e / p
    b = f * g + b
    b = b + b
    p = g + p
    g = m
    m = kc + m
    
    if (abs(g - kc) .gt. g * CA) then
        kc = sqrt(e)
        kc = kc + kc
        e = kc * m
        goto 1
    end if
    cel = pihalf * ((a * m + b) / (m * (m + p)))

return
end

end module ellip

module phot_nograd
use iso_c_binding
use ellip

implicit none

!real*8, parameter :: pi = 4.d0 * Atan(1.d0), pihalf = 2.d0 * Atan(1.d0)
real*8, parameter :: twopithree = 8.d0 * Atan(1.d0) / 3.d0, twopi = 8.d0 * Atan(1.d0)
real*8, parameter :: o3 = 1.d0 / 3.d0, o9 = 1.d0 / 9.d0
real*8, parameter :: pithird = 4.d0 * Atan(1.d0) / 3.d0, pisixth = 4.d0 * Atan(1.d0) / 6.d0

contains

subroutine phis_ng(rp, rm, bp, bm, bpm, cth, sth, pp1, pp2, pm1, pm2)

    real*8 :: rp, rm, bp, bm, bpm, cth, sth
    
    ! intersection angle from planet center, intersection from moon center, same 
    ! values relative to bp and bm vectors respectively
    real*8 :: pp, pm, pp1, pm1, pp2, pm2
    
    ! Four times the area of the triangle formed by rm, rp, and bpm
    real*8 :: delta
    ! Variables used in sorting the sides of the triangle
    real*8 :: a, b, c, tmp
    
    ! angle between bpm vector and bp vector, 
    ! angle between bpm vector and bm vector
    real*8 :: theta, thetam
    
    ! for avoiding divisions
    real*8 :: obm
    
    thetam = Atan2(bp * sth, bpm - bp * cth)
    theta = Atan2(sth, cth)
    obm = 1.d0 / bm
    
    ! find 4 * area of triangle using modified Heron's formula 
    a = rp
    b = rm
    c = bpm
    if (c .gt. b) then
        tmp = c
        c = b
        b = tmp
    end if
    if (b .gt. a) then
        tmp = b
        b = a
        a = tmp
    end if
    delta = Sqrt((a + (b + c)) * (c - (a - b)) * (c + (a - b)) * (a + (b - c)))
    pm = Atan2(delta, (rm - rp) * (rm + rp) + bpm * bpm)   
    pp = Atan2(delta, (rp - rm) * (rp + rm) + bpm * bpm)

    pm1 = thetam + pm
    pm2 = thetam - pm
    pp1 = theta + pp
    pp2 = theta - pp
    
    if (pm1 .gt. pi) then
        pm1 = pm1 - twopi
    end if
    if (pp1 .gt. pi) then
        pp1 = pp1 - twopi
    end if

end

subroutine kappas_p_ng(rp, bp, kp, kps)

    ! kp = angle to intersection from center of planet, 
    ! kps = angle to intersection from center of star 
    real*8 :: rp, bp, kp, kps
    
    ! variables used in sorting sides of triangle
    real*8 :: a, b, c
    
    ! four times the area of the triangle with sides rp, bp, and 1
    real*8 :: delta
    
    if (bp .gt. 1.d0) then
        a = bp
        b = 1.d0
        c = rp
    else
        a = 1.d0
        b = bp
        c = rp
        if (rp .gt. bp) then
            b = rp
            c = bp
        end if
    end if
    delta = Sqrt((a + (b + c)) * (c - (a - b)) * (c + (a - b)) * (a + (b - c)))
    kps = Atan2(delta, (1.d0 - rp) * (1.d0 + rp) + bp * bp)
    kp = Atan2(delta, (rp - 1.d0) * (rp + 1.d0) + bp * bp)
end 

subroutine kappas_m_ng(rm, bp, bm, bpm, cth, sth, km, kms)

    ! km = angle to interection from center of moon, 
    ! kms = angle to intersection from center of planet
    real*8 :: rm, bp, bm, bpm, cth, sth, km, kms
    
    ! variables used in sorting sides of triangle
    real*8 :: a, b, c
    
    ! four times the area of the triangle with sides rm, bm, and 1
    real*8 :: delta
    
    ! some useful quantities
    real*8 :: denom, xs, xm, yp, ypm, ytheta
    
    xs = (1.d0 - bm) * (1.d0 + bm) - rm * rm
    xm = (rm - bm) * (rm + bm) - 1.d0
    yp = bp - bpm * cth
    ypm = bpm - bp * cth
    ytheta = bp * bpm * sth
    
    if (bm .ge. 1.d0) then
        a = bm
        b = 1.d0
        c = rm
    else
        a = 1.d0
        b = bm
        c = rm
        if (rm .ge. bm) then
            b = rm
            c = bm
        end if
    end if
    delta = Sqrt((a + (b + c)) * (c - (a - b)) * (c + (a - b)) * (a + (b - c)))
    denom = 1.d0 / (delta * bm * bm)
    
    km = Atan2(delta, (rm - 1.d0) * (rm + 1.d0) + bm * bm)
    kms = Atan2(delta, (1.d0 - rm) * (1.d0 + rm) + bm * bm)
end 


! main loop to compute the flux at each timestep by finding the correct geometry and
! calling the integration routines 
subroutine flux_ng(c1, c2, rp, rm, bp, bpm, cth, sth, lc, j) bind(C, name="flux_ng")

    integer (c_int), bind(C) :: j
    integer :: i
    real (c_double), bind(C) :: rp, rm
    real (c_double), bind(C), dimension(j) :: bp, cth, sth, bpm
    real (c_double), bind(C), intent(out), dimension(j) :: lc
    real*8 :: f0
    real*8, dimension(3) :: ld
    real (c_double), bind(C) :: c1, c2
    real*8 :: of0
    
    ! half angles: from planet to planet/star intersection, moon to moon/star
    ! intersection, spanned by planet on limb of star, spanned by moon on 
    ! limb of star
    real*8 :: kp, km, kps, kms
    
    ! angles to planet-moon intersection from planet center 
    !relative to bp vector (and derivatives)
    real*8 :: pp1, pp2
    
    ! angles to planet-moon intersection from moon center 
    ! relative to bm vector (and derivatves)
    real*8 :: pm1, pm2
    
    ! used to determine cases for three body overlaps, might not be needed. 
    ! Check if some of these (costheta, cosphi) can be removed when optimizing things later 
    real*8 :: phi, d1, d2, delta, a, b, c, tmp
    
    ! For chain rule stuff
    real*8, dimension(j) :: bm
    
    bm = Sqrt((bp - bpm)**2.d0 + 2 * bp * bpm * (1.d0 - cth))
    
    ld(1) = 1.d0 - c1 - 2 * c2
    ld(2) = c1 + 2 * c2
    ld(3) = c2
    
    ! normalization factors 
    f0 = ld(1) * pi + ld(2) * twopithree + ld(3) * pihalf
    
    of0 = 1.d0 / f0
    
    do i=1,j,1
    
        lc(i) = f0 * of0
        
        if (rp .gt. 1.d0 + bp(i)) then
            lc(i) = 0.d0
        else if (rm .gt. 1.d0 + bm(i)) then 
            lc(i) = 0.d0
        else if (bpm(i) .gt. rp + rm) then
            ! moon and planet don't overlap each other 
            if (bp(i) .lt. 1.d0 - rp) then
                ! planet completely inside star
                lc(i) = lc(i) - 2 * Fcomplete_ng(ld, rp, bp(i)) * of0
            else if (bp(i) .lt. 1.d0 + rp) then
                ! planet partially overlaps star
                call kappas_p_ng(rp, bp(i), kp, kps)
                lc(i) = lc(i) - 2 * (Fstar_ng(ld, kps) &
                                    + F_ng(ld, kp, rp, bp(i), .TRUE.)) * of0
            end if
            if (bm(i) .lt. 1.d0 - rm) then
                ! moon completely inside star
                lc(i) = lc(i) - 2 * Fcomplete_ng(ld, rm, bm(i)) * of0
            else if (bm(i) .lt. 1.d0 + rm) then
                ! moon partially overlaps star
                call kappas_m_ng(rm, bp(i), bm(i), bpm(i), cth(i), sth(i), km, kms)
                lc(i) = lc(i) - 2 * (Fstar_ng(ld, kms) &
                                    + F_ng(ld, km, rm, bm(i), .TRUE.)) * of0
            end if
        else
            ! moon and planet do overlap each other 
            if (bp(i) .gt. rp + 1.d0) then
                if (bm(i) .gt. rm + 1.d0) then
                    ! neither moon nor planet overlap star
                    lc(i) = f0 * of0
                else
                    ! moon partially overlaps star, planet does not overlap star
                    call kappas_m_ng(rm, bp(i), bm(i), bpm(i), cth(i), sth(i), km, kms)
                    lc(i) = 2 * (Fstar_ng(ld, pi - kms) &
                                    - F_ng(ld, km, rm, bm(i), .TRUE.)) * of0

                end if
            else
                if (bm(i) .gt. rm + 1.d0) then
                    ! planet partially overlaps star, moon is outside of star
                    call kappas_p_ng(rp, bp(i), kp, kps)
                    lc(i) = 2 * (Fstar_ng(ld, pi - kps) &
                                    - F_ng(ld, kp, rp, bp(i), .TRUE.)) * of0
                else
                    if (bp(i) + rp .le. 1.d0) then
                        if (bm(i) + rm .le. 1.d0) then
                            if (bpm(i) + rm .le. rp) then
                                ! moon and planet both overlap star, moon is completely overlapped by planet
                                lc(i) = (f0 - 2 * Fcomplete_ng(ld, rp, bp(i))) * of0
                            else
                                ! Case E
                                ! moon and planet both overlap star, moon and planet partially overlap each other 
                                call phis_ng(rp, rm, bp(i), bm(i), bpm(i), cth(i), sth(i), pp1, pp2, pm1, pm2)
                                lc(i) = (f0 - Arc_ng(ld, pp1, pp2, rp, bp(i), .FALSE., .FALSE.) &
                                                - Arc_ng(ld, pm1, pm2, rm, bm(i), .FALSE., .FALSE.)) * of0
                            end if
                        else
                            ! planet fully overlaps star, moon partially overlaps star, both overlap each other 
                            call phis_ng(rp, rm, bp(i), bm(i), bpm(i), cth(i), sth(i), pp1, pp2, pm1, pm2)
                            call kappas_m_ng(rm, bp(i), bm(i), bpm(i), cth(i), sth(i), km, kms)
                            lc(i) = (2 * Fstar_ng(ld, pi - kms) &
                                        - Arc_ng(ld, -km, pm2, rm, bm(i), .TRUE., .FALSE.) &
                                        - Arc_ng(ld, pm1, km, rm, bm(i), .FALSE., .TRUE.) &
                                        - Arc_ng(ld, pp1, pp2, rp, bp(i), .FALSE., .FALSE.)) * of0
                        end if
                    else
                        if (bm(i) + rm .le. 1.d0) then 
                            if (bpm(i) + rm .le. rp) then
                                ! planet partially overlaps star, moon fully overlaps star but is completely overlapped by planet 
                                call kappas_p_ng(rp, bp(i), kp, kps)
                                lc(i) = 2 * (Fstar_ng(ld, pi - kps) &
                                                - F_ng(ld, kp, rp, bp(i), .TRUE.)) * of0
                            else
                                ! planet partially overlaps star, moon fully overlaps star and only partially overlaps planet
                                call phis_ng(rp, rm, bp(i), bm(i), bpm(i), cth(i), sth(i), pp1, pp2, pm1, pm2)
                                call kappas_p_ng(rp, bp(i), kp, kps)
                                lc(i) = (2 * Fstar_ng(ld, pi - kps) &
                                            - Arc_ng(ld, -kp, pp2, rp, bp(i), .TRUE., .FALSE.) &
                                            - Arc_ng(ld, pp1, kp, rp, bp(i), .FALSE., .TRUE.) &
                                            - Arc_ng(ld, pm1, pm2, rm, bm(i), .FALSE., .FALSE.)) * of0
                            end if
                        else
                            if (bpm(i) + rm .le. rp) then
                                ! planet and moon both partially overlap star but moon is fully overlapped by the planet
                                call kappas_p_ng(rp, bp(i), kp, kps)
                                lc(i) = 2 * (Fstar_ng(ld, pi - kps) &
                                                - F_ng(ld, kp, rp, bp(i), .TRUE.)) * of0
                            else
                                call kappas_p_ng(rp, bp(i), kp, kps)
                                call kappas_m_ng(rm, bp(i), bm(i), bpm(i), cth(i), sth(i), km, kms)
                                
                                a = bm(i)
                                b = bp(i)
                                c = bpm(i)
                                if (b .gt. a) then
                                    tmp = b
                                    b = a
                                    a = tmp
                                end if
                                if (c .gt. b) then
                                    tmp = c
                                    c = b
                                    b = tmp
                                end if
                                if (b .gt. a) then
                                    tmp = b
                                    b = a
                                    a = tmp
                                end if
                                delta = (a + (b + c)) * (c - (a - b)) * (c + (a - b)) * (a + (b - c))
                                if (delta .lt. 0.d0) then
                                    delta = 0.d0
                                else
                                    delta = Sqrt(delta)
                                end if
                                phi = Atan2(delta, (bm(i) - bpm(i)) * (bm(i) + bpm(i)) + bp(i) * bp(i)) 
                                
                                call phis_ng(rp, rm, bp(i), bm(i), bpm(i), cth(i), sth(i), pp1, pp2, pm1, pm2)
                                
                                if (phi + kms .le. kps) then 
                                        if (abs(pp2) .gt. kp) then
                                            ! planet and moon both partially overlap the star and each other but the 
                                            ! moon-star overlap is contained within the planet-star overlap
                                            lc(i) = 2 * (Fstar_ng(ld, pi - kps) &
                                                            - F_ng(ld, kp, rp, bp(i), .TRUE.)) * of0
                                        else
                                            ! planet and moon both partially overlap star and each other but the 
                                            ! moon-star intersections are overlapped by the planet
                                            lc(i) = (2 * Fstar_ng(ld, pi - kps) &
                                                        - Arc_ng(ld, -kp, pp2, rp, bp(i), .TRUE., .FALSE.) &
                                                        - Arc_ng(ld, pp1, kp, rp, bp(i), .FALSE., .TRUE.) &
                                                        - Arc_ng(ld, pm1, pm2, rm, bm(i), .FALSE., .FALSE.)) * of0
                                        end if
                                else if (phi + kps .le. kms) then
                                    if ((bp(i) - rp) .le. (bm(i) - rm)) then
                                        ! planet and moon both partially overlap the star and each other but the 
                                        ! planet-star intersections are overlapped by the moon
                                        lc(i) = (2 * Fstar_ng(ld, pi - kms) &
                                                        - Arc_ng(ld, -km, pm2, rm, bm(i), .TRUE., .FALSE.) &
                                                        - Arc_ng(ld, pm1, km, rm, bm(i), .FALSE., .TRUE.) &
                                                        - Arc_ng(ld, pp1, pp2, rp, bp(i), .FALSE., .FALSE.)) * of0
                                    else
                                        ! planet and moon both partially overlap the star and each other but 
                                        ! the planet-star overlap is  entirely within the moon-star overlap
                                        lc(i) = 2 * (Fstar_ng(ld, pi - kms) &
                                                        - F_ng(ld, km, rm, bm(i), .TRUE.)) * of0
                                    end if
                                else
                                    ! bookmark
                                    d1 = rm * rm + bm(i) * bm(i) - 2 * rm * bm(i) * Cos(pm2)
                                    d2 = rm * rm + bm(i) * bm(i) - 2 * rm * bm(i) * Cos(pm1)
                                    if ((d1 .gt. 1.d0) .AND. (d2 .gt. 1.d0)) then
                                        ! planet and moon both partially overlap star and each other, 
                                        ! but the planet/moon overlap does not overlap the star
                                        lc(i) = 2 * (Fstar_ng(ld, pi - (kps + kms)) &
                                                        - F_ng(ld, kp, rp, bp(i), .TRUE.) &
                                                        - F_ng(ld, km, rm, bm(i), .TRUE.)) * of0
                                    else if ((d1 .le. 1.d0) .AND. (d2 .le. 1.d0)) then
                                        ! planet and moon both partially overlap star and each other, 
                                        ! with the planet/moon overlap fully overlapping the star
                                        lc(i) = (2 * Fstar_ng(ld, pi - (kps + kms)) &
                                                        - Arc_ng(ld, -km, -pm1, rm, bm(i), .TRUE., .FALSE.) &
                                                        - Arc_ng(ld, -pm2, km, rm, bm(i), .FALSE., .TRUE.) &
                                                        - Arc_ng(ld, pp1, kp, rp, bp(i), .FALSE., .TRUE.) &
                                                        - Arc_ng(ld, -kp, pp2, rp, bp(i), .TRUE., .FALSE.)) * of0
                                    else
                                        ! planet and moon both partially overlap star and each other, 
                                        ! with the planet/moon overlap partially overlapping the star
                                        
                                        lc(i) = (2 * Fstar_ng(ld, pi - 0.5 * (kps + kms + phi)) &
                                                        - Arc_ng(ld, -pm2, km, rm, bm(i), .FALSE., .TRUE.) &
                                                        - Arc_ng(ld, -kp, pp2, rp, bp(i), .TRUE., .FALSE.)) * of0
                                    end if
                                end if
                            end if
                        end if
                    end if
                end if
            end if  
        end if
        lc(i) = lc(i) - f0 * of0
    end do
    return
    
end

! work out the right sign and order of the integration and call the integration routine 
! to integrate along an arbitrary arc of the planet or moon 
function Arc_ng(ld, phi1, phi2, r, b, limbflag1, limbflag2)
                    
    real*8 :: Arc_ng

    logical :: limbflag1, limbflag2
    real*8 :: phi1, phi2, r, b
    real*8, dimension(3) :: ld
        
    if (phi1 < 0) then
        if (phi2 > 0) then
            Arc_ng = F_ng(ld, phi2, r, b, limbflag2) &
                + F_ng(ld, -phi1, r, b, limbflag1)
            return
        else
            if (phi2 < phi1) then
                Arc_ng = 2 * Fcomplete_ng(ld, r, b) &
                    + F_ng(ld, -phi1, r, b, limbflag1) &
                    - F_ng(ld, -phi2, r, b, limbflag2)
                return
            else
                Arc_ng = - F_ng(ld, -phi2, r, b, limbflag2) &
                      + F_ng(ld, -phi1, r, b, limbflag1)
                return
            end if
        end if
    else
        if (phi2 < 0) then
            Arc_ng = 2 * Fcomplete_ng(ld, r, b) &
                - F_ng(ld, phi1, r, b, limbflag1) &
                - F_ng(ld, -phi2, r, b, limbflag2)
            return
        else
            if (phi2 < phi1) then
                Arc_ng = 2 * Fcomplete_ng(ld, r, b) &
                    + F_ng(ld, phi2, r, b, limbflag2) &
                    - F_ng(ld, phi1, r, b, limbflag1)
                return
            else
                Arc_ng = F_ng(ld, phi2, r, b, limbflag2) &
                    - F_ng(ld, phi1, r, b, limbflag1)
                return
            end if
        end if
    end if
    
    return
    
end function

! integrate along the limb of the star
function Fstar_ng(ld, phi)

    real*8 :: Fstar_ng
    real*8, dimension(3) :: F_

    real*8 :: phi
    real*8, dimension(3) :: ld
        
    F_(1) = 0.5 * phi
    F_(2) = phi * o3
    F_(3) = 0.25 * phi
    
    Fstar_ng = Sum(ld * F_)
    return
    
end function

! integrate around the entire planet/moon 
function Fcomplete_ng(ld, r, b)

    real*8 :: Fcomplete_ng
    real*8, dimension(3) :: F_
    
    ! Limb darkening params
    real*8, dimension(3) :: ld
    
    ! self explanatory
    real*8 :: r, b
    
    ! convenient parameters
    real*8 :: r2, b2, br, bmr, bpr, obmr
    real*8 :: x, ox, o

    
    ! For the integral
    real*8 :: alpha, beta, gamma, n, m
    real*8 :: sgn
    real*8 :: ur, ub, vb, sqomm
    
    ! Elliptic integrals
    real*8 :: ellippi
    real*8 :: eplusf
    
    r2 = r * r
    b2 = b * b
    bmr = b - r
    obmr = 1.d0 / bmr
    bpr = b + r
    br = b * r
    
    F_(1) = r2 * pihalf  
    F_(3) = pihalf * r2 * (b2 + 0.5 * r2) 
    
    x = Sqrt((1.d0 - bmr) * (1.d0 + bmr))
    ox = 1.d0 / x
            
    alpha = (7 * r2 + b2 - 4.d0) * o9 * x
    beta = (r2 * r2 + b2 * b2 + r2 - b2 * (5.d0 + 2 * r2) + 1.d0) * o9 * ox        
            
    n = -4 * br * obmr * obmr
    m = 4 * br * ox * ox
            
    ur = 2 * r * x
    ub = x * ((b + 1.d0) * (b - 1.d0) + r2) / (3 * b)
    vb = ((-1.d0 + b2)**2.d0 - 2 * (1.d0 + b2) * r2 + r2 * r2) * o3 * ox / b
            
    sqomm = Sqrt(1.d0 - m)
    o = 1.d0
            
    if (b .eq. r) then 
        ellippi = 0.d0
        sgn = 0.d0
        gamma = 0.d0
    else
        ellippi = cel((sqomm), (1.d0 - n), (o), (o))
        sgn = Sign(1.d0, bmr)
        gamma = bpr * ox * o3 * obmr
    end if 

    eplusf = cel((sqomm), (o), alpha + beta, beta + alpha * (1.d0 - m))
            
    F_(2) = eplusf + gamma * ellippi + pisixth * (1.d0 - sgn)
    
    Fcomplete_ng = Sum(ld * F_)
    return

end function

! evaluate the integral at one arbitrary limit along the planet or moon's boundary 
function F_ng(ld, phi, r, b, limbflag)

    real*8 :: F_ng
    real*8, dimension(3) :: F_
    
    ! Are we integrating along the edge of the moon or the planet? 
    logical :: limbflag
    
    ! Limb darkening params
    real*8, dimension(3) :: ld
    
    ! self explanatory
    real*8 :: phi, r, b
    
    ! convenient parameters
    real*8 :: sphi, cphi, tphihalf, sphihalf, cphihalf
    real*8 :: r2, b2, br, bmr, bpr, obmr
    real*8 :: x, y, z, ox, oy, oz, tans, o
    
    ! For the integral
    real*8 :: alpha, beta, gamma, d, n, m
    real*8 :: ur, vr, ub, vb, pr, pb, sqomm
    
    ! Elliptic integrals
    real*8 :: ellippi
    real*8 :: eplusf
    
    r2 = r * r
    b2 = b * b
    bmr = b - r
    obmr = 1.d0 / bmr
    bpr = b + r
    br = b * r
    
    cphi = Cos(phi)
    sphi = Sin(phi)
    sphihalf = Sin(phi * 0.5)
    cphihalf = Cos(phi * 0.5)
    tphihalf = sphihalf / cphihalf
    
    if (phi .eq. pi) then
        F_ng = Fcomplete_ng(ld, r, b)
        return
    end if
        
    F_(1) = 0.5 * (r2 * phi - br * sphi)
    F_(3) = 0.25 * (r * (r * (2 * b2 + r2) * phi &
          + b * (-b2 - 3 * r2 + br * cphi) * sphi))
          
    y = Sqrt(br)
    oy = 1.d0 / y
    x = b2 + r2 - 2 * br * cphi
    ox = 1.d0 / x
          
    pr = - b * sphi * o3 * ox
    pb = r * sphi * o3 * ox
                
    if (bpr .gt. 1.d0) then
        
        y = Sqrt(br)
        oy = 1.d0 / y
        x = b2 + r2 - 2 * br * cphi
        ox = 1.d0 / x
            
        alpha = 2 * y * (7 * r2 + b2 - 4.d0) * o9
        beta = -(3.d0 + 2*r*(b2 * b + 5 * b2 * r + 3*r*(-2.d0 + r2) + b*(-4.d0 + 7*r2))) * o9 * 0.5 * oy
        gamma = bpr * o3 * 0.5 * oy * obmr
            
        m = (1.d0 - bmr) * (1.d0 + bmr) * 0.25 * oy * oy
        n = ((bmr + 1.d0) * (bmr - 1.d0)) * obmr * obmr
        sqomm = Sqrt(1.d0 - m)

        ur = 4 * r * y
        vr = - r * (bpr + 1.d0) * (bpr - 1.d0) * oy
        ub = 2 * r * (b2 + r2 - 1.d0) * o3 * oy
        vb = vr * o3
            
        if (limbflag) then
            
            d = phi * o3 * 0.5 - Atan(bpr * tphihalf * obmr) * o3
                
            o = 1.d0
            ellippi = cel((sqomm), 1.d0 - n, (o), (o))
            eplusf = cel((sqomm), (o), alpha + beta, beta + alpha * (1.d0 - m))
        else                
            z = Sqrt((1.d0 - b) * (1.d0 + b) - r2 + 2 * br * cphi)
            oz = 1.d0 / z
            d = o3 * (phi * 0.5 - Atan(bpr * tphihalf * obmr)) &
                - (2 * br * o9) * sphi * z
                    
            pr = - ((1.d0 - x)**(1.5d0) - 1.d0) * pr
            pb = (1.d0 - (1.d0 + x) * Sqrt(1.d0 - x)) * pb 
             
            tans = 1.d0 / Sqrt(m / (sphihalf * sphihalf) - 1.d0)
                
            o = 1.d0
            ellippi = el3((tans), (sqomm), 1.d0 - n)
            eplusf = el2((tans), (sqomm), alpha + beta, beta + alpha * (1.d0 - m))

        end if
        F_(2) = eplusf + gamma * ellippi + d
            
    else
        
        y = Sqrt((1.d0 - bmr) * (1.d0 + bmr))
        oy = 1.d0 / y
            
        alpha = (7 * r2 + b2 - 4.d0) * y * o9
        beta = (r2 * r2 + b2 * b2 + r2 - b2 * (5.d0 + 2 * r2) + 1.d0) * o9 * oy
        gamma = bpr * o3 * oy * obmr
                        
        n = -4 * br * obmr * obmr
        m = 4 * br * oy * oy
            
        sqomm = Sqrt(1.d0 - m)
        
        pr = - ((1.d0 - x)**(1.5d0) - 1.d0) * pr
        pb = (1.d0 - (1.d0 + x) * Sqrt(1.d0 - x)) * pb
            
        ur = 2 * r * y
        ub = y * ((b + 1.d0) * (b - 1.d0) + r2) / (3 * b)
        vb = (b2 * b2 + ((r - 1.d0) * (r + 1.d0))**2.d0 - 2 * b2 * (1.d0 + r2)) / (3 * b * y) 
            
        d = o3 * (phi * 0.5 - Atan(bpr * tphihalf * obmr)) &
            - 2 * br * o9 * sphi * Sqrt(1.d0 - x)
             
        o = 1.d0
            
        if (b .eq. r) then
            ellippi = 0.d0
            gamma = 0.d0
        else
            ellippi = el3((tphihalf), (sqomm), (1.d0 - n))
        end if
                
        eplusf = el2((tphihalf), (sqomm), alpha + beta, beta + alpha * (1.d0 - m))
            
        F_(2) = eplusf + gamma * ellippi + d
    end if
            
    F_ng = Sum(ld * F_)

    return
end function

end module phot_nograd

module kepler
use iso_c_binding
implicit none

real*8, parameter :: pi = 4.d0 * Atan(1.d0), G = 8.887692445125634d-10
real*8, parameter :: o3 = 1.d0 / 3.d0, o6 = 1.d0 / 6.d0, pi_o12 = Atan(1.d0) / 3.d0
real*8, parameter :: if3 = 1.d0 / 6.d0, if5 = 1.d0 / (6.d0 * 20), if7 = 1.d0 / (6.d0 * 20 * 42)
real*8, parameter :: if9 = 1.d0 / (6.d0 * 20 * 42 * 72), if11 = 1.d0 / (6.d0 * 20 * 42 * 72 * 110)
real*8, parameter :: if13 = 1.d0 / (6.d0 * 20 * 42 * 72 * 110 * 156), if15 = 1.d0 / (6.d0 * 20 * 42 * 72 * 110 * 156 * 210)

contains

subroutine kepler_solve(M, ecc, cosf, sinf, j) bind(C, name="kepler_solve")
    integer :: j, i
    real*8 :: tol, err, x, ecc
    real (c_double), bind(C), dimension(j) :: M
    real (c_double), bind(C), dimension(j), intent(out) :: cosf, sinf
    real*8, dimension(j) :: tanfhalf, tanfhalf2, denom, E, sE, cE
    
    if (ecc .lt. 1.d-10) then
        cE = Cos(M)
        sE = Sin(M)
        
        tanfhalf = sE / (1.d0 + cE)
        tanfhalf2 = tanfhalf * tanfhalf
        denom = 1.d0 / (tanfhalf2 + 1.d0)
         cosf = (1.d0 - tanfhalf2) * denom
         sinf = 2 * tanfhalf * denom
     else
         tol = 1.d-10

         E = M
         x = Sqrt((1.d0 + ecc) / (1.d0 - ecc))
        
        do i=1,j,1
            err = 1.d0
            do while (abs(err) .gt. tol)
                err = - (E(i) - ecc * Sin(E(i)) - M(i)) / (1.d0 - ecc * Cos(E(i)))
                E(i) = E(i) + err
            end do
        end do    
        
        cE = Cos(E)
        tanfhalf = x * Sin(E) / (1.d0 + cE)
        tanfhalf2 = tanfhalf * tanfhalf
        denom = 1.d0 / (tanfhalf2 + 1.d0)
        cosf = (1.d0 - tanfhalf2) * denom
        sinf = 2 * tanfhalf * denom
    end if
end

function sine(x)

    real*8 :: sine
    real*8 :: x, x2
    
    x2 = x * x
    
    sine = x * (1.d0 - x2 * (if3 - &
                    x2 * (if5 - x2 * (if7 - x2 * (if9 - x2 * (if11 - x2 * (if13 - x2 * if15)))))))

end 

! copied from DFM's exoplanet code
function EAstart(M, ecc)

    real*8 :: EAstart
    real*8 :: M, ecc
    real*8 :: ome, sqrt_ome, chi, Lam, S, sigma, s2, s4, denom, E
    
    ome = 1.d0 - ecc
    sqrt_ome = Sqrt(ome)
    chi = M / (sqrt_ome * ome)
    Lam = Sqrt(8.d0 + 9 * chi * chi)
    S = (Lam + 3 * chi) ** (1.d0 / 3.d0)
    sigma = 6 * chi / (2.d0 + S * S + 4.d0 / (S * S))
    s2 = sigma * sigma
    s4 = s2 * s2
    
    denom = 1.d0 / (s2 + 2.d0)
    E = sigma * (1.d0 + s2 * ome * denom * ((s2 + 20.d0) / 60.d0 &
        + s2 * ome * denom * denom * (s2 * s4 + 25 * s4 + 340 * s2 + 840) / 1400))
    EAstart = E * sqrt_ome
end

! pretty much verbatim from DFM's exoplanet code 
subroutine kepler_solve_RPP(M, ecc, cosf, sinf, j) bind(C, name="kepler_solve_RPP")

    integer :: j
    integer :: i, k
    real*8, bind(C) :: ecc
    real*8, dimension(j), bind(C) :: M, cosf, sinf 
    real*8 :: tanfhalf, tanfhalf2, d
    real*8 :: g2s_e, g3s_e, g4s_e, g5s_e, g6s_e
    real*8, dimension(0:12) :: bounds
    real*8, dimension(0:8) :: EA_tab
    real*8 :: MA, EA, sE, cE, x, y
    real*8 :: B0, B1, B2, dx, idx
    integer :: MAsign, sig
    real*8 :: over_ecc
    real*8 :: num, denom, dEA
    
    g2s_e = 0.2588190451025207623489 * ecc
    g3s_e = 0.5 * ecc
    g4s_e = 0.7071067811865475244008 * ecc
    g5s_e = 0.8660254037844386467637 * ecc
    g6s_e = 0.9659258262890682867497 * ecc
    
    bounds(0) = 0.d0
    bounds(1) = pi_o12 - g2s_e
    bounds(2) = pi * o6 - g3s_e
    bounds(3) = pi * 0.25 - g4s_e
    bounds(4) = pi * o3 - g5s_e
    bounds(5) = 5 * pi_o12 - g6s_e
    bounds(6) = pi * 0.5 - ecc
    bounds(7) = 7 * pi_o12 - g6s_e
    bounds(8) = 2 * pi * o3 - g5s_e
    bounds(9) = 3 * pi * 0.25 - g4s_e
    bounds(10) = 5 * pi * o6 - g3s_e
    bounds(11) = 11 * pi_o12 - g2s_e
    bounds(12) = pi
    
    over_ecc = 1.d17
    if (ecc .gt. 1.d-17) then
        over_ecc = 1.d0 / ecc
    end if 
    
    do i=1,j,1
        MAsign = 1
        MA = Modulo(M(i), 2 * pi)
        if (MA .gt. pi) then 
            MAsign = -1
            MA = 2 * pi - MA
        end if
    
        if (2 * MA + 1.d0 - ecc .lt. 0.2d0) then 
            EA = EAstart(MA, ecc)
        else
            do k = 11, 1 , -1
                if (MA .gt. bounds(k)) then
                    exit
                end if
            end do
            EA_tab(0) = k * pi_o12
            EA_tab(6) = (k + 1.d0) * pi_o12
            if (k .ge. 6) then
                sig = 1
            else
                sig = -1
            end if
            
            x = 1.d0 / (1.d0 - ((6.d0 - k) * pi_o12 + sig * bounds(abs(6 - k))))
            y = -0.5 * (k * pi_o12 - bounds(k))
            EA_tab(1) = x
            EA_tab(2) = y * x * x * x
            
            x = 1.d0 / (1.d0 - ((5.d0 - k) * pi_o12 + sig * bounds(abs(5 - k))))
            y = -0.5 * ((k + 1.d0) * pi_o12 - bounds(k + 1))
            EA_tab(7) = x
            EA_tab(8) = y * x * x * x
            
            idx = 1.d0 / (bounds(k + 1) - bounds(k))
            
            B0 = idx * (-EA_tab(2) - idx * (EA_tab(1) - idx * pi_o12))
            B1 = idx * (-2 * EA_tab(2) - idx * (EA_tab(1) - EA_tab(7)))
            B2 = idx * (EA_tab(8) - EA_tab(2))
            
            EA_tab(3) = B2 - 4 * B1 + 10 * B0
            EA_tab(4) = (-2 * B2 + 7 * B1 - 15 * B0) * idx
            EA_tab(5) = (B2 - 3 * B1 + 6 * B0) * idx * idx
            
            dx = MA - bounds(k)
            EA = EA_tab(0) &
                 + dx * (EA_tab(1) + dx * (EA_tab(2) + dx * (EA_tab(3) + dx * (EA_tab(4) + dx * EA_tab(5)))))
                 
        end if
                 
        if (EA .lt. pi * 0.25) then
            sE = sine(EA)
            cE = Sqrt(1.d0 - sE * sE)
        else if (EA .gt. 3 * pi * 0.25) then 
            sE = sine(pi - EA)
            cE = - Sqrt(1.d0 - sE * sE)
        else
            cE = sine(pi * 0.5 - EA)
            sE = Sqrt(1.d0 - cE * cE)
        end if
            
        num = (MA - EA) * over_ecc + sE
        denom = over_ecc - cE
        dEA = num * denom / (denom * denom + 0.5 * sE * num)
            
        if ((ecc .lt. 0.78d0) .OR. (MA .gt. 0.4d0)) then 
            sinf(i) = MAsign * (sE * (1.d0 - 0.5 * dEA * dEA) + dEA * cE)
            cosf(i) = cE * (1.d0 - 0.5 * dEA * dEA) - dEA * sE
        else
            dEA = num / (denom + dEA * (0.5 * sE + o6 * cE * dEA))
            sinf(i) = MAsign * (sE * (1.d0 - 0.5 * dEA * dEA) + dEA * cE * (1.d0 - dEA * dEA * o6))
            cosf(i) = cE * (1.d0 - 0.5 * dEA * dEA) - dEA * sE * (1.d0 - dEA * dEA * o6)
        end if
        
        denom = 1.d0 + cosf(i)
        if (denom .gt. 1.d-10) then 
            x = Sqrt((1.d0 + ecc) / (1.d0 - ecc))
            tanfhalf = x * sinf(i) / (1.d0 + cosf(i))
            tanfhalf2 = tanfhalf * tanfhalf
            d = 1.d0 / (tanfhalf2 + 1.d0)
            cosf(i) = (1.d0 - tanfhalf2) * d
            sinf(i) = 2 * tanfhalf * d
        else
            cosf(i) = -1.d0
            sinf(i) = 0.d0
        end if
        
    end do
    
end

! pretty much verbatim from DFM's exoplanet code 
subroutine grad_kepler_solve_RPP(M, ecc, cosf, sinf, f_e, f_M, j)

    integer :: j, i, k
    real*8 :: ecc
    real*8, dimension(j) :: M, cosf, sinf
    real*8 :: tanfhalf, tanfhalf2, d
    real*8, dimension(j) :: f_e, f_M
    real*8 g2s_e, g3s_e, g4s_e, g5s_e, g6s_e
    real*8, dimension(0:12) :: bounds
    real*8, dimension(0:8) :: EA_tab
    real*8 :: MA, EA, sE, cE, x, y
    real*8 :: B0, B1, B2, dx, idx
    integer :: MAsign, sig
    real*8 :: over_ecc
    real*8 :: num, denom, dEA
    
    g2s_e = 0.2588190451025207623489 * ecc
    g3s_e = 0.5 * ecc
    g4s_e = 0.7071067811865475244008 * ecc
    g5s_e = 0.8660254037844386467637 * ecc
    g6s_e = 0.9659258262890682867497 * ecc
    
    bounds(0) = 0.d0
    bounds(1) = pi_o12 - g2s_e
    bounds(2) = pi * o6 - g3s_e
    bounds(3) = pi * 0.25 - g4s_e
    bounds(4) = pi * o3 - g5s_e
    bounds(5) = 5 * pi_o12 - g6s_e
    bounds(6) = pi * 0.5 - ecc
    bounds(7) = 7 * pi_o12 - g6s_e
    bounds(8) = 2 * pi * o3 - g5s_e
    bounds(9) = 3 * pi * 0.25 - g4s_e
    bounds(10) = 5 * pi * o6 - g3s_e
    bounds(11) = 11 * pi_o12 - g2s_e
    bounds(12) = pi
    
    over_ecc = 1.d17
    if (ecc .gt. 1.d-17) then
        over_ecc = 1.d0 / ecc
    end if 
    
    do i=1,j,1
        MAsign = 1
        MA = Modulo(M(i), 2 * pi)
        if (MA .gt. pi) then 
            MAsign = -1
            MA = 2 * pi - MA
        end if
    
        if (2 * MA + 1.d0 - ecc .lt. 0.2d0) then 
            EA = EAstart(MA, ecc)
        else
            do k = 11, 1 , -1
                if (MA .gt. bounds(k)) then
                    exit
                end if
            end do
            EA_tab(0) = k * pi_o12
            EA_tab(6) = (k + 1.d0) * pi_o12
            if (k .ge. 6) then
                sig = 1
            else
                sig = -1
            end if
            
            x = 1.d0 / (1.d0 - ((6.d0 - k) * pi_o12 + sig * bounds(abs(6 - k))))
            y = -0.5 * (k * pi_o12 - bounds(k))
            EA_tab(1) = x
            EA_tab(2) = y * x * x * x
            
            x = 1.d0 / (1.d0 - ((5.d0 - k) * pi_o12 + sig * bounds(abs(5 - k))))
            y = -0.5 * ((k + 1.d0) * pi_o12 - bounds(k + 1))
            EA_tab(7) = x
            EA_tab(8) = y * x * x * x
            
            idx = 1.d0 / (bounds(k + 1) - bounds(k))
            
            B0 = idx * (-EA_tab(2) - idx * (EA_tab(1) - idx * pi_o12))
            B1 = idx * (-2 * EA_tab(2) - idx * (EA_tab(1) - EA_tab(7)))
            B2 = idx * (EA_tab(8) - EA_tab(2))
            
            EA_tab(3) = B2 - 4 * B1 + 10 * B0
            EA_tab(4) = (-2 * B2 + 7 * B1 - 15 * B0) * idx
            EA_tab(5) = (B2 - 3 * B1 + 6 * B0) * idx * idx
            
            dx = MA - bounds(k)
            EA = EA_tab(0) &
                 + dx * (EA_tab(1) + dx * (EA_tab(2) + dx * (EA_tab(3) + dx * (EA_tab(4) + dx * EA_tab(5)))))
                 
        end if
                 
        if (EA .lt. pi * 0.25) then
            sE = sine(EA)
            cE = Sqrt(1.d0 - sE * sE)
        else if (EA .gt. 3 * pi * 0.25) then 
            sE = sine(pi - EA)
            cE = - Sqrt(1.d0 - sE * sE)
        else
            cE = sine(pi * 0.5 - EA)
            sE = Sqrt(1.d0 - cE * cE)
        end if
            
        num = (MA - EA) * over_ecc + sE
        denom = over_ecc - cE
        dEA = num * denom / (denom * denom + 0.5 * sE * num)
            
        if ((ecc .lt. 0.78d0) .OR. (MA .gt. 0.4d0)) then 
            sinf(i) = MAsign * (sE * (1.d0 - 0.5 * dEA * dEA) + dEA * cE)
            cosf(i) = cE * (1.d0 - 0.5 * dEA * dEA) - dEA * sE
        else
            dEA = num / (denom + dEA * (0.5 * sE + o6 * cE * dEA))
            sinf(i) = MAsign * (sE * (1.d0 - 0.5 * dEA * dEA) + dEA * cE * (1.d0 - dEA * dEA * o6))
            cosf(i) = cE * (1.d0 - 0.5 * dEA * dEA) - dEA * sE * (1.d0 - dEA * dEA * o6)
        end if
        
        denom = 1.d0 + cosf(i)
        if (denom .gt. 1.d-10) then 
            x = Sqrt((1.d0 + ecc) / (1.d0 - ecc))
            tanfhalf = x * sinf(i) / (1.d0 + cosf(i))
            tanfhalf2 = tanfhalf * tanfhalf
            d = 1.d0 / (tanfhalf2 + 1.d0)
            cosf(i) = (1.d0 - tanfhalf2) * d
            sinf(i) = 2 * tanfhalf * d
        else
            cosf(i) = -1.d0
            sinf(i) = 0.d0
        end if
        
    end do
    
    x = 1.d0 - ecc**2.d0
    f_M = (1.d0 + ecc * cosf)**2.d0 / x**1.5d0
    f_e = (2.d0 + ecc * cosf) * sinf / x
end

end
